## zsv 1.3.0

=== Makefile ===
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_DIR:=$(shell basename "${THIS_MAKEFILE_DIR}")
THIS_MAKEFILE:=$(lastword $(MAKEFILE_LIST))

THIS_MAKE=`basename ${MAKE}`

CONFIGFILE ?= config.mk
include ${CONFIGFILE}

CONFIGFILEPATH=$(shell ls ${CONFIGFILE} >/dev/null 2>/dev/null && realpath ${CONFIGFILE})
ifeq (${CONFIGFILEPATH},)
  $(error Config file ${CONFIGFILE} not found)
endif

help:
	@echo "**** Welcome to zsv+lib ****"
	@echo
	@echo "This package has two primary components:"
	@echo "* zsvlib  : a fast CSV parser library"
	@echo "* zsv     : CSV editor and toolkit (that uses zsvlib)"
	@echo
	@echo "\`zsv\` also supports dynamic extensions, a sample of which you can"
	@echo "build and run as described in docs/extension.md"
	@echo
	@echo "To build, test and install zsvlib and zsv:"
	@echo "  ./configure && ${THIS_MAKE} test"
	@echo
	@echo "To build and install zsvlib and zsv:"
	@echo "  ./configure && ${THIS_MAKE} install"
	@echo
	@echo "To build and install only zsvlib:"
	@echo "  ./configure && ${THIS_MAKE} -C src install"
	@echo
	@echo "To build and install only zsv (i.e. install both, remove zsvlib):"
	@echo "  ./configure && ${THIS_MAKE} install && ${THIS_MAKE} -C src uninstall"
	@echo
	@echo "To save and build from a configuration without losing the current one,"
	@echo "use the configuration option CONFIGFILE e.g.:"
	@echo "  ./configure --config-file=/path/to/config.custom"
	@echo "  ./configure && ${THIS_MAKE} -C src CONFIGFILE=/path/to/config.custom install"
	@echo
	@echo "To clean (remove temporary build objects) (after running configure):"
	@echo "  ${THIS_MAKE} clean"
	@echo
	@echo "To uninstall libs and apps:"
	@echo "  ${THIS_MAKE} uninstall"
	@echo
	@echo "To test:"
	@echo "  ${THIS_MAKE} test"
	@echo
	@echo "Additional make options available for the library or the apps by"
	@echo "  running ${THIS_MAKE} from the src or app directory"
	@echo
	@echo "For more information, see README.md"

check test:
	@${MAKE} -C app test CONFIGFILE=${CONFIGFILEPATH}
	@${MAKE} -C examples/lib test CONFIGFILE=${CONFIGFILEPATH}

build install uninstall: % :
	@${MAKE} -C src $* CONFIGFILE=${CONFIGFILEPATH}
	@${MAKE} -C app $* CONFIGFILE=${CONFIGFILEPATH}

clean:
	@${MAKE} -C src clean CONFIGFILE=${CONFIGFILEPATH}
	@${MAKE} -C app clean-all CONFIGFILE=${CONFIGFILEPATH}
	@rm -rf ${THIS_MAKEFILE_DIR}/build

.PHONY: help build install uninstall clean check test

=== app/Makefile ===
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))

CONFIGFILE ?= ../config.mk
$(info Using config file ${CONFIGFILE})

CONFIGFILEPATH:=$(shell ls ${CONFIGFILE} >/dev/null 2>/dev/null && realpath ${CONFIGFILE})
ifeq ($(CONFIGFILEPATH),)
  ifeq ($(shell dirname ${CONFIGFILE}),.)
    CONFIGFILEPATH:=$(shell ls ../${CONFIGFILE} >/dev/null 2>/dev/null && realpath ../${CONFIGFILE})
    ifneq ($(CONFIGFILEPATH),)
      $(info Config file ${CONFIGFILE} not found; using ../${CONFIGFILE})
    endif
  endif
endif

ifeq ($(CONFIGFILEPATH),)
  $(error Config file ${CONFIGFILE} not found)
else
  include ${CONFIGFILEPATH}
endif

CC ?= cc

CFLAGS_EXE ?=

LIB_SUFFIX=
LIBZSV_L=-lzsv${LIB_SUFFIX}
LIBZSV_A=libzsv${LIB_SUFFIX}.a
LIBZSV=${BUILD_DIR}/lib/${LIBZSV_A}
LIBZSV_INSTALL=${LIBDIR}/${LIBZSV_A}

# if we are incorporating these commands into another project, we might
# want to use different values for ZSV_TEMPFILE_SUFFIX and ZSV_CACHE_PREFIX
# to do: set these in the configure script
ifneq ($(ZSV_TEMPFILE_SUFFIX),)
  CFLAGS+= -DZSV_TEMPFILE_SUFFIX='${ZSV_TEMPFILE_SUFFIX}'
endif
ifneq ($(ZSV_CACHE_PREFIX),)
  CFLAGS+= -DZSV_CACHE_PREFIX='${ZSV_CACHE_PREFIX}'
endif

CFLAGS+=-fsigned-char
ifneq ($(WIN),)
  CFLAGS+= -Wno-incompatible-pointer-types
  LIBS+=-lShlwapi
endif

ifneq ($(ZSV_IS_PROP_FILE_HANDLER),)
	CFLAGS+=-DZSV_IS_PROP_FILE_HANDLER=${ZSV_IS_PROP_FILE_HANDLER}
endif
ifneq ($(ZSV_IS_PROP_FILE_DEPTH),)
	CFLAGS+=-DZSV_IS_PROP_FILE_DEPTH=${ZSV_IS_PROP_FILE_DEPTH}
endif

ifeq ($(ZSV_NO_ONLY_CRLF),1)
  CFLAGS+= -DZSV_NO_ONLY_CRLF
endif

DEBUG=0
WIN=
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif

MORE_OBJECTS=
NO_LTO=0

ifeq ($(DEBUG),1)
  NO_LTO=1
  DBG_SUBDIR+=dbg
else
  DBG_SUBDIR+=rel
endif

ifeq ($(NO_LTO),1)
  CFLAGS+= -fno-lto
else
  CFLAGS+=${CFLAGS_LTO}
  LDFLAGS_OPT+= ${LDFLAGS_OPT_LTO}
endif

NO_STDIN=
ifeq ($(NO_STDIN),1)
  CFLAGS+= -DNO_STDIN
endif

CFLAGS+= ${CFLAGS_PIC}

CONFIGURE_HOST?=
ifeq ($(CONFIGURE_HOST),)
ifneq ($(HOST),)
  CONFIGURE_HOST=$(HOST)
endif
endif

ifeq ($(WIN),0)
  BUILD_SUBDIR=$(shell uname)/${DBG_SUBDIR}
  EXE=
  ifneq ($(findstring emcc,$(CC)),) # emcc
    NO_THREADING ?= 1
    NO_PLAYGROUND ?= 1
    EXE=.em.js
    ifeq ($(NO_PLAYGROUND),0) # wasm playground
      LDFLAGS += -sEXPORTED_RUNTIME_METHODS="['callMain']" -sINVOKE_RUN=0 -sALLOW_MEMORY_GROWTH=1
    else
      CFLAGS += -DNO_PLAYGROUND
      LDFLAGS += -sEXPORTED_FUNCTIONS="['_free','_malloc']"
      LDFLAGS += -sEXPORTED_RUNTIME_METHODS="['setValue','allocateUTF8','stringToUTF8Array','lengthBytesUTF8','writeArrayToMemory']"
      LDFLAGS += -sRESERVED_FUNCTION_POINTERS=4 -sALLOW_MEMORY_GROWTH=1
    endif
    LDFLAGS += -sFORCE_FILESYSTEM=1 -lidbfs.js -sMAIN_MODULE
    ifneq ($(NO_THREADING),1)
      CFLAGS+=-pthread
      LDFLAGS += -sUSE_PTHREADS=1 -sPTHREAD_POOL_SIZE=2
    endif
  endif
else
  BUILD_SUBDIR=win/${DBG_SUBDIR}
  EXE=.exe
  CFLAGS+= -D__USE_MINGW_ANSI_STDIO -D_ISOC99_SOURCE -D_GNU_SOURCE
  CFLAGS+= -Wl,--strip-all
  CONFIGURE_HOST=x86_64-w64-mingw32
  CFLAGS+=-Dsetenv\(a,b,c\)=_putenv_s\(a,b\)
endif

JQ_CONFIGURE_HOST=
ifneq ($(CONFIGURE_HOST),)
  JQ_CONFIGURE_HOST=--host=$(CONFIGURE_HOST)
endif

CFLAGS+=-std=gnu11
CFLAGS+=-Wunused
CFLAGS_O ?=
ifeq ($(CFLAGS_O),)
  ifeq ($(DEBUG),0)
    CFLAGS_O=-O3
  else
    CFLAGS_O=-O0
  endif
endif

CFLAGS+=${CFLAGS_O}

CFLAGS+=-Wshadow -Wall -Wextra
ifeq ($(DEBUG),0)
  CFLAGS+=-DNDEBUG -Wno-gnu-statement-expression -Wno-missing-braces -pedantic -DSTDC_HEADERS -D_GNU_SOURCE ${CFLAGS_OPT} #-ftree-vectorize

  ifeq ($(PGO),1)
    CFLAGS+= -fprofile-generate -fprofile-dir=/tmp/p4
  else
    ifeq ($(PGO),2)
      CFLAGS+= -fprofile-use=/tmp/p4
    else
      $(echo "No profiling set. To use PGO, compile with PGO=1, then run with data, then compile again with PGO=2")
    endif
  endif
else
  CFLAGS += ${CFLAGS_DEBUG}
endif

CCBN=$(shell basename ${CC})
CFLAGS+= -I${PREFIX}/include
THIS_LIB_BASE:=$(shell cd .. && pwd)
INCLUDE_DIR:=${THIS_LIB_BASE}/include
BUILD_DIR:=${THIS_LIB_BASE}/build/${BUILD_SUBDIR}/${CCBN}
UTILS1=writer file err signal mem clock arg dl string dirs prop cache jq os index chunk

ZSV_EXTRAS ?=

ifneq ($(findstring emcc,$(CC)),) # emcc
  ZSV_EXTRAS=1
  UTILS1+=emcc/fs_api
  ifneq ($(NO_THREADING),1)
    LDFLAGS+=-pthread
  endif
else # not emcc
  CFLAGS+= ${CFLAGS_AVX} ${CFLAGS_SSE}
  LDFLAGS+=-lpthread # Linux explicitly requires
endif

ifeq ($(ZSV_EXTRAS),1)
  UTILS1+= overwrite overwrite_writer
endif

UTILS=$(addprefix ${BUILD_DIR}/objs/utils/,$(addsuffix .o,${UTILS1}))

ifeq ($(NO_THREADING),1)
  CFLAGS+= -DNO_THREADING
  ZSV_NO_PARALLEL=1
endif

ifeq ($(ZSV_NO_PARALLEL),1)
  CFLAGS+=-DZSV_NO_PARALLEL
endif


ifeq ($(ZSV_EXTRAS),1)
  CFLAGS+= -DZSV_EXTRAS
endif

OBJECTS=${UTILS}

ifeq ($(NO_MEMMEM),1)
  OBJECTS+= ${BUILD_DIR}/objs/utils/memmem.o
  CFLAGS+=-DNO_MEMMEM
  UTIL_A_OBJ_WIN=memmem
endif

ZSV=$(BINDIR)/zsv${EXE}

SOURCES=echo paste check count count-pull select select-pull 2tsv 2json serialize flatten pretty stack desc sql 2db compare prop rm mv jq
ifeq ($(ZSV_EXTRAS),1)
  SOURCES+=overwrite
endif
CLI_SOURCES=echo select desc count paste check 2tsv pretty sql flatten 2json serialize stack 2db compare prop rm mv jq
ifeq ($(ZSV_EXTRAS),1)
  CLI_SOURCES+=overwrite
endif

ifeq ($(ZSVSHEET_BUILD),1)
  SOURCES+=sheet
  CLI_SOURCES+=sheet
  CFLAGS+=-DZSVSHEET_BUILD
  CFLAGS+=${CFLAGS_NCURSES}
  LDFLAGS+=${LDFLAGS_NCURSES}
endif

CFLAGS+= -DUSE_JQ

STATIC_LIB_FLAGS=
ifeq ($(STATIC_BUILD),1)
  STATIC_LIB_FLAGS=${LDFLAGS_STATIC}
else
  ifneq ($(STATIC_LIBS),)
    STATIC_LIB_FLAGS=${LDFLAGS_STATIC}
  endif
endif

STANDALONE_PFX=${BUILD_DIR}/bin/zsv_

TARGETS=$(addprefix ${STANDALONE_PFX},$(addsuffix ${EXE},${SOURCES})) ${CLI}

BUILDS=$(addprefix build-,${SOURCES})
CLEANS=$(addprefix clean-,${SOURCES})

## cli
VERSION= $(shell (git describe --always --dirty --tags 2>/dev/null || echo "v0.0.0-zsv") | sed 's/^v//')
CLI_OBJ_PFX=${BUILD_DIR}/objs/cli_
CLI_APP_OBJECT=${CLI_OBJ_PFX}cli.o
CLI=${BUILD_DIR}/bin/cli${EXE}
ifneq ($(findstring emcc,$(CC)),) # emcc
  CLI_ADDITIONAL=${BUILD_DIR}/bin/cli.em.wasm
endif
CLI_OBJECTS=$(addprefix ${CLI_OBJ_PFX},$(addsuffix .o,${CLI_SOURCES}))

CFLAGS+=${CFLAGS_AUTO}

ifeq ($(VERBOSE),1)
  CFLAGS+= ${CFLAGS_VECTORIZE_OPTIMIZED} ${CFLAGS_VECTORIZE_MISSED} ${CFLAGS_VECTORIZE_ALL}
endif

INIH_SRC=${THIS_MAKEFILE_DIR}/external/inih
INIH_INCLUDE=${THIS_MAKEFILE_DIR}/external/inih
INIH_OBJECT=${BUILD_DIR}-external/inih/inih.o
CLI_INCLUDE+= -I${INIH_INCLUDE}

YAJL_SRC_DIR=${THIS_MAKEFILE_DIR}/external/yajl
YAJL_OBJ1=yajl yajl_alloc yajl_buf yajl_encode yajl_gen yajl_lex yajl_parser yajl_tree yajl_version
YAJL_OBJ=$(addprefix ${BUILD_DIR}-external/yajl/,$(addsuffix .o,${YAJL_OBJ1}))
YAJL_INCLUDE=-I${YAJL_SRC_DIR}/build/yajl-2.1.1/include

YAJL_HELPER_OBJ=${BUILD_DIR}-external/yajl_helper/yajl_helper.o
YAJL_HELPER_INCLUDE=-I${THIS_MAKEFILE_DIR}/external/yajl_helper
CFLAGS+=${YAJL_HELPER_INCLUDE} ${YAJL_INCLUDE}

# jq
JQ_TARBALL=${THIS_MAKEFILE_DIR}/external/jq-1.6.tar.gz
JQ_SRC=${BUILD_DIR}-external/jq-src

JQ_PREFIX ?=
ifeq ($(JQ_PREFIX),)
  JQ_PREFIX=${BUILD_DIR}-external/jq-build
  JQ_INCLUDE_DIR=${JQ_PREFIX}/include
  JQ_BUNDLE_LIB=${JQ_PREFIX}/lib/libjq.a
  JQ_LIB=${JQ_BUNDLE_LIB}
else
  JQ_INCLUDE_DIR=${JQ_PREFIX}/include
  JQ_LIB=
endif

## json writer
JSONWRITER_SRC=${THIS_MAKEFILE_DIR}/external/json_writer-1.01
JSONWRITER_INCLUDE=-I${THIS_MAKEFILE_DIR}/external/json_writer-1.01
JSONWRITER_OBJECT=${BUILD_DIR}-external/json_writer-1.01/jsonwriter.o

## memfile
MEMFILE_SRC=${THIS_MAKEFILE_DIR}/external/memfile-1.0/src
MEMFILE_INCLUDE=-I${THIS_MAKEFILE_DIR}/external/memfile-1.0/include
MEMFILE_OBJECT=${BUILD_DIR}-external/memfile-1.0/memfile.o

## utf8proc
UTF8PROC_SRC=${THIS_MAKEFILE_DIR}/external/utf8proc-2.6.1
UTF8PROC_INCLUDE=${THIS_MAKEFILE_DIR}/external/utf8proc-2.6.1
UTF8PROC_OBJECT=${BUILD_DIR}-external/utf8proc-2.6.1/utf8proc.o
CFLAGS+= -I${UTF8PROC_INCLUDE} -DUTF8PROC -DUTF8PROC_STATIC

# sqlite3
SQLITE_SRC=${THIS_MAKEFILE_DIR}/external/sqlite3/sqlite3*.c
SQLITE_EXT=${BUILD_DIR}-external/sqlite3/sqlite3_and_csv_vtab.o
SQLITE_EXT_INCLUDE=-I${THIS_MAKEFILE_DIR}/external/sqlite3

SQL_INTERNAL_OBJECT=${BUILD_DIR}/objs/sql_internal.o

# everything uses prop, which in turn uses yajl and jq and json and sqlite3
OBJECTS+= ${YAJL_OBJ} ${YAJL_HELPER_OBJ} ${BUILD_DIR}/objs/utils/json.o ${SQLITE_EXT}
MORE_SOURCE+= ${YAJL_INCLUDE} ${YAJL_HELPER_INCLUDE} -I${JQ_INCLUDE_DIR} ${SQLITE_EXT_INCLUDE}
MORE_LIBS+=${JQ_LIB} ${LDFLAGS_JQ}

help:
	@echo "To build: ${MAKE} [DEBUG=1] [STATIC_BUILD=1] [clean] [clean-all] [BINDIR=${BINDIR}] [JQ_PREFIX=/usr/local] <install|all|install-util-lib|test>"
	@echo
	@echo "If JQ_PREFIX is not defined, libjq will be built in the build dir"
	@echo "If STATIC_BUILD is set to 1, will build with -static flag, if the compiler supports it"
	@echo
	@echo "To build and test individual apps, run:"
	@echo "  ${MAKE} test"
	@echo "which will build and test all apps, or to build/test a single app:"
	@echo "  ${MAKE} test-xx"
	@echo "where xx is any of:"
	@echo "  echo count count-pull paste check select select-pull 2tsv 2json serialize flatten pretty stack desc sql 2db prop rm mv overwrite"
	@echo ""
	@echo "To run benchmarks:"
	@echo "  ${MAKE} benchmark"
	@echo ""

install: ${ZSV}

benchmark: ${STANDALONE_PFX}select${EXE} ${STANDALONE_PFX}count${EXE} ${STANDALONE_PFX}2tsv${EXE}
	make -C benchmark all

uninstall-all: uninstall uninstall-util-lib

uninstall:
	rm -rf ${ZSV}

ZSV_UTIL_A=${LIBDIR}/libzsvutil.a
${ZSV_UTIL_A}:SQLITE_EXT=
${ZSV_UTIL_A}:SQLITE_EXT_INCLUDE=
${ZSV_UTIL_A}: ${BUILD_DIR}/objs/utils/util.a
	@mkdir -p `dirname $@`
	cp -p $< $@

UTIL_A_OBJ:=writer file dirs-no-jq os ${UTIL_A_OBJ_WIN}
UTIL_A_OBJ:=$(addprefix ${BUILD_DIR}/objs/utils/,$(addsuffix .o,${UTIL_A_OBJ}))

${BUILD_DIR}/objs/utils/util.a: ${UTIL_A_OBJ}
	$(AR) rcv $@ $^ # $?
	$(RANLIB) $@
	$(AR) -t $@ # check it is there
	@echo Built $@

uninstall-util-lib:
	@rm -f ${ZSV_UTIL_A}

install-util-lib: ${ZSV_UTIL_A}

build: ${CLI}

all: ${TARGETS}

${LIBZSV_INSTALL}:
	${MAKE} -C ../src CONFIGFILE=${CONFIGFILEPATH} install DEBUG=${DEBUG}

${ZSV}: ${CLI}
	@mkdir -p `dirname "$@"`
ifneq ($(findstring emcc,$(CC)),) # emcc
	cp -p $< `dirname "$@"`/
	cp -p ${CLI_ADDITIONAL} `dirname "$@"`/
else
	cp -p $< $@
endif

cli: build-cli

build-cli: ${CLI}

clean-cli:
	@rm -f  ${CLI_APP_OBJECT} ${CLI_OBJECTS}

${BUILDS}: build-%: ${STANDALONE_PFX}%${EXE}
	@echo Built ${STANDALONE_PFX}$*${EXE}

${CLEANS}: clean-%:
	rm -f ${STANDALONE_PFX}$*${EXE}
	rm -f ${BUILD_DIR}/*/*$*.o

.PHONY: all install cli build build-% clean clean-% test test-% lib-% check install-util-lib uninstall-util-lib clean-util-lib

.SECONDARY: ${OBJECTS}

.POSIX:
.SUFFIXES:
.SUFFIXES: .o .c .a

${BUILD_DIR}/objs/sql_internal.o ${BUILD_DIR}/objs/utils/index.o ${BUILD_DIR}/objs/utils/chunk.o: ${BUILD_DIR}/objs/%.o: %.c %.h # ${BUILD_DIR}/objs/%.o: %.c %.h
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -I${INCLUDE_DIR} -o $@ -c $<

${BUILD_DIR}/objs/utils/%.o : utils/%.c ${INCLUDE_DIR}/zsv/utils/%.h ${JQ_LIB}
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -I${INCLUDE_DIR} -I${UTF8PROC_INCLUDE} -DINCLUDE_SRC -o $@ -c utils/$*.c ${MORE_SOURCE}

${BUILD_DIR}/objs/utils/dirs-no-jq.o : utils/dirs.c ${INCLUDE_DIR}/zsv/utils/dirs.h
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -I${INCLUDE_DIR} -I${UTF8PROC_INCLUDE} -DINCLUDE_SRC -o $@ -c utils/dirs-no-jq.c ${MORE_SOURCE}

${BUILD_DIR}/objs/zsv_%.o: %.c
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -I${INCLUDE_DIR} -I${UTF8PROC_INCLUDE} -c $< -o $@

${UTF8PROC_OBJECT}: ${UTF8PROC_SRC}/utf8proc.c
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -I${UTF8PROC_INCLUDE} -c ${UTF8PROC_SRC}/utf8proc.c -o $@

${INIH_OBJECT}: ${INIH_SRC}/ini.c
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -I${INIH_INCLUDE} -DINI_HANDLER_LINENO=1 -DINI_CALL_HANDLER_ON_NEW_SECTION=1 -c $< -o $@

${CLI_APP_OBJECT} : cli_ini.c builtin/*.c ${JQ_LIB}

=== fuzz/Makefile ===
.PHONY: build run clean help

INCLUDE_DIR=/usr/local/include
FUZZOUT=/tmp/zsvfuzzout
FUZZBIN=/tmp/zsvfuzz

help:
	@echo "To run fuzzer:"
	@echo "  make run [INCLUDE_DIR=/usr/local/include]"
	@echo ""
	@echo "Requirements:"
	@echo "  afl-clang-fast and afl-fuzz must be installed"
	@echo "  zsv.h must be present in INCLUDE_DIR"
	@echo ""

clean:
	rm -f $(FUZZBIN) $(FUZZOUT) $(FUZZBIN).dSYM

build: $(FUZZBIN)

$(FUZZBIN): fuzz.c
	afl-clang-fast -o $(FUZZBIN) -g3 -fsanitize=address,undefined fuzz.c -I/usr/local/include

run: $(FUZZBIN)
	@echo "Output will be written to $(FUZZOUT)"
	afl-fuzz -i ../data/test -o $(FUZZOUT) $(FUZZBIN)

=== src/Makefile ===
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_DIR:=$(shell basename "${THIS_MAKEFILE_DIR}")
THIS_MAKEFILE:=$(lastword $(MAKEFILE_LIST))

.POSIX:
.SUFFIXES:
.SUFFIXES: .o .c .a

CONFIGFILE ?=../config.mk
$(info Using config file ${CONFIGFILE})

CONFIGFILEPATH:=$(shell ls ${CONFIGFILE} >/dev/null 2>/dev/null && realpath ${CONFIGFILE})
ifeq ($(CONFIGFILEPATH),)
  ifeq ($(shell dirname ${CONFIGFILE}),.)
    CONFIGFILEPATH:=$(shell ls ../${CONFIGFILE} >/dev/null 2>/dev/null && realpath ../${CONFIGFILE})
    ifneq ($(CONFIGFILEPATH),)
      $(info Config file ${CONFIGFILE} not found; using ../${CONFIGFILE})
    endif
  endif
endif

ifeq ($(CONFIGFILEPATH),)
  $(error Config file ${CONFIGFILE} not found)
else
  include ${CONFIGFILEPATH}
endif

CC ?= cc
AWK ?= awk
AR ?= ar
RANLIB ?= ranlib
SED ?= sed

WIN=
DEBUG=0
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif

ifeq ($(BUILD_SHAREDLIB),1)
  include ${THIS_MAKEFILE_DIR}/../make/sharedlib.mk # sets SHAREDLIB_EXT
endif

CFLAGS+= ${CFLAG_O} ${CFLAGS_OPT}
CFLAGS+= ${CFLAGS_AUTO}

CFLAGS+=-fsigned-char

ifeq ($(VERBOSE),1)
  CFLAGS+= ${CFLAGS_VECTORIZE_OPTIMIZED} ${CFLAGS_VECTORIZE_MISSED} ${CFLAGS_VECTORIZE_ALL}
endif

VERSION= $(shell (git describe --always --dirty --tags 2>/dev/null || echo "v0.0.0-zsv") | sed 's/^v//')

ZSV_EXTRAS ?=
ifneq ($(findstring emcc,$(CC)),) # emcc
  ZSV_EXTRAS=1
  NO_THREADING=1
else # not emcc
  CFLAGS+= ${CFLAGS_AVX} ${CFLAGS_SSE}
endif

ifeq ($(NO_THREADING),1)
  CFLAGS+= -DNO_THREADING
endif

ifeq ($(ZSV_NO_ONLY_CRLF),1)
  CFLAGS+= -DZSV_NO_ONLY_CRLF
endif

ifeq ($(ZSV_EXTRAS),1)
  CFLAGS+= -DZSV_EXTRAS
endif

ifeq ($(DEBUG),0)
  CFLAGS+= -DNDEBUG -O3  ${CFLAGS_LTO}

  ifeq ($(PGO),1)
    CFLAGS+= -fprofile-generate -fprofile-dir=/tmp/p4
  else
    ifeq ($(PGO),2)
      CFLAGS+= -fprofile-use=/tmp/p4
    else
      $(info No profiling set. To use PGO, compile with PGO=1, then run with data, then compile again with PGO=2)
    endif
  endif
else
  CFLAGS += ${CFLAGS_DEBUG}
endif

ifeq ($(DEBUG),1)
  DBG_SUBDIR+=dbg
else
  DBG_SUBDIR+=rel
endif

ifeq ($(WIN),0)
  BUILD_SUBDIR=$(shell uname)/${DBG_SUBDIR}
  WHICH=which
  EXE=
  CFLAGS+= -fPIC
else
  BUILD_SUBDIR=win/${DBG_SUBDIR}
  WHICH=where
  EXE=.exe
  CFLAGS+= -fpie
  CFLAGS+= -D__USE_MINGW_ANSI_STDIO -D_ISOC99_SOURCE -Wl,--strip-all
endif

CFLAGS+= -std=gnu11 -Wno-gnu-statement-expression -Wshadow -Wall -Wextra -Wno-missing-braces -pedantic -D_GNU_SOURCE

CFLAGS+= ${ZSV_OPTIONAL_CFLAGS}

CCBN=$(shell basename ${CC})
THIS_LIB_BASE=$(shell cd .. && pwd)
INCLUDE_DIR=${THIS_LIB_BASE}/include
BUILD_DIR=${THIS_LIB_BASE}/build/${BUILD_SUBDIR}/${CCBN}

NO_UTF8_CHECK=1

LIB_SUFFIX?=
ZSV_OBJ=${BUILD_DIR}/objs/zsv.o
LIBZSV_STATIC=libzsv${LIB_SUFFIX}.a
LIBZSV_STATIC_BUILD=${BUILD_DIR}/lib/${LIBZSV_STATIC}
LIBZSV_BUILD=${LIBZSV_STATIC_BUILD}
LIBZSV_INSTALL=${LIBDIR}/${LIBZSV_STATIC}

ifeq ($(BUILD_SHAREDLIB),1)
  LIBZSV_SHARED=libzsv.${SHAREDLIB_EXT}
  LIBZSV_SHARED_BUILD+=${BUILD_DIR}/lib/${LIBZSV_SHARED}
  LIBZSV_BUILD+=${LIBZSV_SHARED_BUILD}
  LIBZSV_INSTALL+=${LIBDIR}/${LIBZSV_SHARED}
  ifeq ($(WIN),)
    CFLAGS+= ${CFLAGS_OPENMP}
  endif
else
    CFLAGS+= ${CFLAGS_OPENMP}
endif

ZSV_OBJ_OPTS=
ifeq ($(NO_UTF8_CHECK),1)
  ZSV_OBJ_OPTS+= -DNO_UTF8_CHECK
endif

help:
	@echo "Make options:"
	@echo "  `basename ${MAKE}` build|install|uninstall|clean"
	@echo
	@echo "Optional ake variables:"
	@echo "  [CONFIGFILE=config.mk] [NO_UTF8_CHECK=1] [VERBOSE=1] [LIBDIR=${LIBDIR}] [INCLUDEDIR=${INCLUDEDIR}] [LIB_SUFFIX=]"
	@echo

build: ../include/zsv.h ${LIBZSV_BUILD}

${LIBZSV_STATIC_BUILD}: ${ZSV_OBJ}
	@mkdir -p `dirname "$@"`
	@rm -f $@
	$(AR) rcv $@ $?
	$(RANLIB) $@
	$(AR) -t $@ # check it is there
	@echo Built $@

${LIBZSV_SHARED_BUILD}: zsv.c zsv_internal.c
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} ${CFLAGS_VISIBILITY_HIDDEN} -DZSV_BUILD_SHARED -DZSV_VERSION=\"${VERSION}\" -I${INCLUDE_DIR} ${ZSV_OBJ_OPTS} -shared -fPIC -o $@ $< -I../app/external/sqlite3

../include/zsv.h:
ifeq ($(ZSV_EXTRAS),1)
	@sed 's/__ZSV_EXTRAS__DEFINE__/#ifndef ZSV_EXTRAS\n#define ZSV_EXTRAS\n#endif/' < ../include/zsv.h.in > $@
else
	@sed 's/__ZSV_EXTRAS__DEFINE__//' < ../include/zsv.h.in > $@
endif

install: ../include/zsv.h ${LIBZSV_INSTALL}
	@mkdir -p  $(INCLUDEDIR)
	@cp -p ../include/*.h $(INCLUDEDIR)
	@cp -pR ../include/zsv $(INCLUDEDIR)/
	@echo "include files copied to $(INCLUDEDIR)"

${LIBZSV_INSTALL}: ${LIBDIR}/% : ${BUILD_DIR}/lib/%
	@mkdir -p `dirname "$@"`
	cp -p "$<" "$@"
	@echo "$* installed to $@"

uninstall:
	@rm -rf ${INCLUDEDIR}/zsv*
	 rm  -f ${LIBDIR}/libzsv*

clean:
	rm -rf ${BUILD_DIR}/objs ${LIBZSV_BUILD}
	rm -f ../include/zsv.h

.PHONY: build install uninstall clean  ${LIBZSV_INSTALL}

${BUILD_DIR}/objs/zsv.o: zsv.c zsv_internal.c
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -DZSV_VERSION=\"${VERSION}\" -I${INCLUDE_DIR} ${ZSV_OBJ_OPTS} -o $@ -c $< -I../app/external/sqlite3

=== app/benchmark/Makefile ===
# Makefile for use with GNU make

CONFIGFILE ?= ../../config.mk
$(info # Using config file ${CONFIGFILE})
include ${CONFIGFILE}

PULL=

COUNT=count
SELECT=select
ifeq ($(PULL),1)
  COUNT=count-pull
  SELECT=select-pull
endif

CC ?= cc

WIN=
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif
ifeq ($(DEBUG),1)
  REL=dbg
else
  REL=rel
endif

ifeq ($(WIN),0)
  BUILD_SUBDIR=$(shell uname)/${REL}
else
  BUILD_SUBDIR=win/${REL}
endif

CCBN=$(shell basename ${CC})
ZSVBIN=../../build/${BUILD_SUBDIR}/${CCBN}/bin/zsv_

MAKE_BIN=$(notdir ${MAKE})

TSV_UTILS=~/install/tsv-utils/bin

HAVE_DUCKDB=$(shell command -v duckdb >/dev/null && echo 1 || echo 0)
HAVE_XSV=$(shell command -v xsv >/dev/null && echo 1 || echo 0)
HAVE_C2TSV=$(shell command -v c2tsv >/dev/null && echo 1 || echo 0)
HAVE_TSVUTILS=$(shell [ -f $(TSV_UTILS)/tsv-select ] && echo 1 || echo 0)
HAVE_POLARS=$(shell [ -f venv/bin/activate ] && echo 1 || echo 0)

HAVE_TIME_ALL=$(shell command -v /usr/bin/time >/dev/null && echo 1 || echo 0)

ifeq ($(TIME_ALL),)
  ifeq ($(HAVE_TIME_ALL),1)
    TIME_ALL=1
  endif
endif
ifeq ($(TIME_ALL),1)
  ALL_SUFFIX=_all
  ifeq ($(HAVE_TIME_ALL),1)
    TIMER=/usr/bin/time -l
  else
    $(error /usr/bin/time not found)
  endif
else
  TIMER=time
  ALL_SUFFIX=
endif
AWK_SCRIPT=./benchmark${ALL_SUFFIX}.awk

DATA_TARGETS=worldcitiespop_big # select-worldcitiespop_mil


help:
	@echo "========================================================================"
	@echo "Running benchmarks"
	@echo "------------------------------------------------------------------------"
	@echo "Generating graphs requires gnuplot, gawk and zsv"
	@echo "    ${MAKE_BIN} graph  : run benchmarks and generate graphs"
	@echo "    ${MAKE_BIN} reset  : reset saved e.g. results e.g. csv"
	@echo "------------------------------------------------------------------------"
	@echo "If /usr/bin/time is available, it will be used with -l to get full metrics"
	@echo "To only run timing metrics, set TIME_ALL=0 e.g. \`${MAKE_BIN} graph TIME_ALL=0\`"
	@echo ""
	@echo "========================================================================"
	@echo "Other targets:"
	@echo "------------------------------------------------------------------------"
	@echo "    ${MAKE_BIN} clean  : remove all data, intermediate and result files"
	@echo "    ${MAKE_BIN} all [TIME_ALL=0] [PULL=1] [TSV_UTILS=~/install/tsv-utils/bin]"
	@echo "    ${MAKE_BIN} csv    : same as all but saves to benchmark.csv"
	@echo "    ${MAKE_BIN} CLI    : use CLI instead of standalone command binaries"
	@echo "========================================================================"
	@echo ""
	@echo "------------------------------------------------------------------------"
	@echo "Tool-specific targets"
	@echo "------------------------------------------------------------------------"
	@echo "    ${MAKE_BIN} $(addprefix count-,zsv xsv polars duckdb)"
	@echo "    ${MAKE_BIN} $(addprefix select-,zsv xsv polars duckdb)"
	@echo ""
	@echo "make all does not actually run everything; you can also run:"
	@echo "    ${MAKE_BIN} tsv"
	@echo ""

CLI: ZSVBIN="zsv "

CLI:
	${MAKE} all ZSVBIN=${ZSVBIN} -n | sed 's/[.]*\/.*\/bin\/zsv_/zsv /g' | sh

all: count select

BENCHMARKS_CSV=benchmarks${ALL_SUFFIX}.csv
BENCHMARKS_TXT=benchmarks${ALL_SUFFIX}.txt
BENCHMARKS_AGG_CSV=benchmarks_agg${ALL_SUFFIX}.csv
BENCHMARKS_AGG_SQL=benchmarks_agg${ALL_SUFFIX}.sql

csv: ${BENCHMARKS_CSV}
	@echo "Results saved at $<. To re-run, first run \`make reset\`"

csv_average: benchmarks_average${ALL_SUFFIX}.csv
	@echo "Results saved at $<. To re-run, first run \`make reset\`"

${BENCHMARKS_AGG_CSV}: ${BENCHMARKS_CSV} ${BENCHMARKS_AGG_SQL}
	cat $< | grep -v tsv-utils | zsv sql "`cat ${BENCHMARKS_AGG_SQL}`" > $@.tmp
	mv $@.tmp $@

GRAPH_GP=plot_metrics${ALL_SUFFIX}
GRAPH_TIME_GP=plot_metrics_time${ALL_SUFFIX}
GRAPH_INPUT=/tmp/graph
HAVE_GNUPLOT=$(shell command -v gnuplot > /dev/null && echo 1 || echo 0)

graph: graph-select graph-count graph-combined

graph-count graph-select: graph-%: ${BENCHMARKS_AGG_CSV} ${GRAPH_GP}.gp.in ${GRAPH_TIME_GP}.gp.in
ifneq ($(HAVE_GNUPLOT),1)
	echo "Please install gnuplot" && exit 1
else
	cat ${GRAPH_GP}.gp.in | sed 's#INPUT_CSV#${GRAPH_INPUT}-$*.csv#g' \
	| sed 's/OPERATION/$*/g' > /tmp/${GRAPH_GP}-$*.gp
	zsv select --search '$*' $< | zsv select --search '_big' > ${GRAPH_INPUT}-$*.csv
	gnuplot /tmp/${GRAPH_GP}-$*.gp

	cat ${GRAPH_TIME_GP}.gp.in | sed 's#INPUT_CSV#${GRAPH_INPUT}-$*.csv#g' \
	| sed 's/OPERATION/$*/g' > /tmp/${GRAPH_TIME_GP}-$*.gp
	gnuplot /tmp/${GRAPH_TIME_GP}-$*.gp
	echo "Generated benchmark_$*_time.png and benchmark_$*_memory.png"
endif

GRAPH_GP_COMBINED=plot_combined${ALL_SUFFIX}
graph-combined: graph-combined-select graph-combined-count

graph-combined-select graph-combined-count: graph-combined-%: ${BENCHMARKS_AGG_CSV} ${GRAPH_GP_COMBINED}.gp.in
ifneq ($(HAVE_GNUPLOT),1)
	echo "Please install gnuplot" && exit 1
else
	cat ${GRAPH_GP_COMBINED}.gp.in \
	  | sed 's#INPUT_CSV#${GRAPH_INPUT}-combined-$*.csv#g' \
	  | sed 's#OPERATION#$*#g' \
	  > /tmp/${GRAPH_GP_COMBINED}-$*.gp
	head -n1 $< > ${GRAPH_INPUT}-combined-$*.csv
	grep '$*,worldcitiespop_big' $< >> ${GRAPH_INPUT}-combined-$*.csv
	gnuplot /tmp/${GRAPH_GP_COMBINED}-$*.gp
endif

${BENCHMARKS_TXT}: worldcitiespop.csv
	${MAKE} -e all TIME_ALL=${TIME_ALL} | tee $@.tmp
	@mv $@.tmp $@

${BENCHMARKS_CSV}: ${BENCHMARKS_TXT}
	cat $< | ${AWK_SCRIPT} > $@.tmp
	@mv $@.tmp $@

worldcitiespop_mil.csv:
	curl -LO 'https://burntsushi.net/stuff/worldcitiespop_mil.csv'

worldcitiespop.csv:
	curl -LO 'https://burntsushi.net/stuff/worldcitiespop.csv'

worldcitiespop_big.csv: worldcitiespop.csv
	cat worldcitiespop.csv > $@.tmp
	awk ' NR > 1 { print $0 }' < worldcitiespop.csv >> $@.tmp
	awk ' NR > 1 { print $0 }' < worldcitiespop.csv >> $@.tmp
	mv $@.tmp $@

worldcitiespop_big.tsv worldcitiespop_mil.tsv: %.tsv : %.csv
	zsv 2tsv $< > $@.tmp
	mv $@.tmp $@

count: $(addprefix count-,$(DATA_TARGETS))

count-worldcitiespop_mil count-worldcitiespop_big: count-% : count-intro-% count-zsv-% count-xsv-% count-polars-% count-duckdb-%

### additional convenience targets
count-zsv: $(addprefix count-zsv-,$(DATA_TARGETS))
count-xsv: $(addprefix count-xsv-,$(DATA_TARGETS))
count-polars: $(addprefix count-polars-,$(DATA_TARGETS))
count-duckdb: $(addprefix count-duckdb-,$(DATA_TARGETS))
###


$(addprefix count-intro-,$(DATA_TARGETS)): count-intro-% :
	@echo "-----------------------------------------------"
	@echo "  Benchmarking count: $*"
	@echo "-----------------------------------------------"

count-zsv-worldcitiespop_mil count-zsv-worldcitiespop_big: count-zsv-%: %.csv %.tsv
	@echo "${ZSVBIN}"${COUNT}
	@printf "zsv                  : "
	@(${TIMER} ${ZSVBIN}${COUNT} < $< > /tmp/zsv-$@.count) 2>&1 | xargs
	@printf "zsv                  : "
	@(${TIMER} ${ZSVBIN}${COUNT} < $< >> /tmp/zsv-$@.count) 2>&1 | xargs
	@printf "zsv                  : "
	@(${TIMER} ${ZSVBIN}${COUNT} < $< >> /tmp/zsv-$@.count) 2>&1 | xargs
	@echo ""

	@printf "zsv --parallel       : "
	@(${TIMER} ${ZSVBIN}${COUNT} --parallel $< >/tmp/zsv-parallel-$@.count) 2>&1 | xargs
	@printf "zsv --parallel       : "
	@(${TIMER} ${ZSVBIN}${COUNT} --parallel $< >>/tmp/zsv-parallel-$@.count) 2>&1 | xargs
	@printf "zsv --parallel       : "
	@(${TIMER} ${ZSVBIN}${COUNT} --parallel $< >>/tmp/zsv-parallel-$@.count) 2>&1 | xargs
	@echo ""

count-xsv-worldcitiespop_mil count-xsv-worldcitiespop_big: count-xsv-%: %.csv %.tsv
ifneq ($(HAVE_XSV),1)
	@echo "xsv not found: skipping (run \'brew install xsv\' to install)"
else
	@printf "xsv                  : "
	@(${TIMER} xsv count < $< > /tmp/xsv-$@.count) 2>&1 | xargs
	@printf "xsv                  : "
	@(${TIMER} xsv count < $< >> /tmp/xsv-$@.count) 2>&1 | xargs
	@printf "xsv                  : "
	@(${TIMER} xsv count < $< >> /tmp/xsv-$@.count) 2>&1 | xargs
	@echo ""
endif

count-polars-worldcitiespop_mil count-polars-worldcitiespop_big: count-polars-%: %.csv %.tsv
ifneq ($(HAVE_POLARS),1)
	@echo "polars not found: skipping (run \`make polars-setup\` to set up)"
else
	@printf "polars               : "
	@. ${VENV_ACTIVATE}; (${TIMER} python3 -c 'import polars as pl; print(pl.scan_csv("$<").select(pl.len()).collect().item())' > /tmp/polars-$@.count) 2>&1 | xargs
	@printf "polars               : "
	@. ${VENV_ACTIVATE}; (${TIMER} python3 -c 'import polars as pl; print(pl.scan_csv("$<").select(pl.len()).collect().item())' >> /tmp/polars-$@.count) 2>&1 | xargs
	@printf "polars               : "
	@. ${VENV_ACTIVATE}; (${TIMER} python3 -c 'import polars as pl; print(pl.scan_csv("$<").select(pl.len()).collect().item())' >> /tmp/polars-$@.count) 2>&1 | xargs
	@echo ""

	@printf "polars-1thread       : "
	@. ${VENV_ACTIVATE}; (POLARS_MAX_THREADS=1 ${TIMER} python3 -c 'import polars as pl; print(pl.scan_csv("$<").select(pl.len()).collect().item())' > /tmp/polars-$@.count) 2>&1 | xargs
	@printf "polars-1thread       : "
	@. ${VENV_ACTIVATE}; (POLARS_MAX_THREADS=1 ${TIMER} python3 -c 'import polars as pl; print(pl.scan_csv("$<").select(pl.len()).collect().item())' >> /tmp/polars-$@.count) 2>&1 | xargs
	@printf "polars-1thread       : "
	@. ${VENV_ACTIVATE}; (POLARS_MAX_THREADS=1 ${TIMER} python3 -c 'import polars as pl; print(pl.scan_csv("$<").select(pl.len()).collect().item())' >> /tmp/polars-$@.count) 2>&1 | xargs
	@echo ""
endif

count-duckdb-worldcitiespop_mil count-duckdb-worldcitiespop_big: count-duckdb-%: %.csv %.tsv
ifneq ($(HAVE_DUCKDB),1)
	@echo "duckdb not found: skipping"
else
	@printf "duckdb               : "
	@(${TIMER} duckdb -c "SELECT count(*) FROM '$<'" > /tmp/duckdb-$@.count) 2>&1 | xargs
	@printf "duckdb               : "
	@(${TIMER} duckdb -c "SELECT count(*) FROM '$<'" >> /tmp/duckdb-$@.count) 2>&1 | xargs
	@printf "duckdb               : "
	@(${TIMER} duckdb -c "SELECT count(*) FROM '$<'" >> /tmp/duckdb-$@.count) 2>&1 | xargs
	@echo ""

	@printf "duckdb (QUOTE='')    : "
	@(${TIMER} duckdb -c "SELECT count(*) FROM read_csv('$<',all_varchar=true,quote='')" > /tmp/duckdb-nq-$@.count) 2>&1 | xargs
	@printf "duckdb (QUOTE='')    : "
	@(${TIMER} duckdb -c "SELECT count(*) FROM read_csv('$<',all_varchar=true,quote='')" >> /tmp/duckdb-nq-$@.count) 2>&1 | xargs
	@printf "duckdb (QUOTE='')    : "
	@(${TIMER} duckdb -c "SELECT count(*) FROM read_csv('$<',all_varchar=true,quote='')" >> /tmp/duckdb-nq-$@.count) 2>&1 | xargs
	@echo ""

	@printf "duckdb-1thread (QUOTE='') : "
	@(${TIMER} duckdb -c "SET threads=1; SELECT count(*) FROM read_csv('$<',all_varchar=true,quote='')" > /tmp/duckdb-nq-$@.count) 2>&1 | xargs
	@printf "duckdb-1thread (QUOTE='') : "
	@(${TIMER} duckdb -c "SET threads=1; SELECT count(*) FROM read_csv('$<',all_varchar=true,quote='')" >> /tmp/duckdb-nq-$@.count) 2>&1 | xargs
	@printf "duckdb-1thread (QUOTE='') : "
	@(${TIMER} duckdb -c "SET threads=1; SELECT count(*) FROM read_csv('$<',all_varchar=true,quote='')" >> /tmp/duckdb-nq-$@.count) 2>&1 | xargs
	@echo ""

endif

tsv: worldcitiespop_mil.csv
	@echo "${ZSVBIN}"2tsv

	@printf "zsv                  : "
	@(${TIMER} ${ZSVBIN}2tsv < $< > /dev/null) 2>&1 | xargs
	@printf "zsv                  : "
	@(${TIMER} ${ZSVBIN}2tsv < $< > /dev/null) 2>&1 | xargs
	@printf "zsv                  : "
	@(${TIMER} ${ZSVBIN}2tsv < $< > /dev/null) 2>&1 | xargs
	@echo ""

	@printf "tsv-utils (csv2tsv)  : "
	@(${TIMER} ~/install/tsv-utils/bin/csv2tsv < $< > /dev/null) 2>&1 | xargs
	@printf "tsv-utils (csv2tsv)  : "
	@(${TIMER} ~/install/tsv-utils/bin/csv2tsv < $< > /dev/null) 2>&1 | xargs
	@printf "tsv-utils (csv2tsv)  : "
	@(${TIMER} ~/install/tsv-utils/bin/csv2tsv < $< > /dev/null) 2>&1 | xargs
	@echo ""

ifneq ($(HAVE_C2TSV),1)
	@echo "c2tsv not found-- skipping"
else
	@printf "c-blake/nio/c2tsv    : " # from https://github.com/c-blake/nio
	@(${TIMER} c2tsv < $< > /dev/null)  2>&1 | xargs
	@printf "c-blake/nio/c2tsv    : "
	@(${TIMER} c2tsv < $< > /dev/null)  2>&1 | xargs
	@printf "c-blake/nio/c2tsv    : "
	@(${TIMER} c2tsv < $< > /dev/null)  2>&1 | xargs
endif

=== app/ext_example/Makefile ===
#Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_DIR:=$(shell basename "${THIS_MAKEFILE_DIR}")
THIS_MAKEFILE:=$(lastword $(MAKEFILE_LIST))

.POSIX:
.SUFFIXES:
.SUFFIXES: .o .c .a

CONFIGFILE ?= config.mk
$(info Using config file ${CONFIGFILE})
include ${CONFIGFILE}
CONFIGFILEPATH=$(shell ls ${CONFIGFILE} >/dev/null 2>/dev/null && realpath ${CONFIGFILE})
ifeq ($(CONFIGFILEPATH),)
  $(error Config file ${CONFIGFILE} not found)
endif

CC ?= cc

WIN=
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif

IS_WSL=$(shell grep -qi microsoft /proc/version 2>/dev/null && echo 1 || echo 0)

ifeq ($(WIN),0)
  EXE=
  EXT=
else
  EXE=.exe
  EXT=.win
endif

export CMP=cmp
export TMP_DIR=./../../tmp

ifeq ($(DEBUG),1)
  DBG_SUBDIR+=dbg
else
  DBG_SUBDIR+=rel
endif

ifeq ($(WIN),0)
  BUILD_SUBDIR=$(shell uname)/${DBG_SUBDIR}
  SO=so
  ifeq ($(BUILD_SUBDIR),Linux)
    CFLAGS+= -ldl -lpthread
  endif
else
  BUILD_SUBDIR=win/${DBG_SUBDIR}
  CFLAGS+= -D__USE_MINGW_ANSI_STDIO -D_ISOC99_SOURCE
  CFLAGS+= -Wl,--strip-all
  SO=dll
endif
CFLAGS+= ${CFLAGS_PIC}

ifeq ($(ZSVSHEET_BUILD),1)
  CFLAGS+=-DZSVSHEET_BUILD
endif

ifeq ($(ZSV_EXTRAS),1)
  CFLAGS+= -DZSV_EXTRAS
endif

DEBUG=0
ifeq ($(DEBUG),0)
  CFLAGS+= -O3 -DNDEBUG -std=gnu11 -Wno-gnu-statement-expression -Wshadow -Wall -Wextra -Wno-missing-braces -pedantic -DSTDC_HEADERS -D_GNU_SOURCE -lm -ftree-vectorize -flto
else
  CFLAGS += -g
endif

export THIS_LIB_BASE=$(shell cd ../.. && pwd)
CCBN=$(shell basename ${CC})
BUILD_DIR=${THIS_LIB_BASE}/build/${BUILD_SUBDIR}/${CCBN}
TARGET=${BUILD_DIR}/bin/zsvextmy.${SO}
TARGET_SHEET=${BUILD_DIR}/bin/zsvextmysheet.${SO}

COLOR_NONE=\033[0m
COLOR_GREEN=\033[1;32m
COLOR_RED=\033[1;31m
COLOR_BLUE=\033[1;34m
COLOR_PINK=\033[1;34m
COLOR_YELLOW=\033[1;33m

TEST_INIT=printf "${COLOR_PINK}$@: ${COLOR_NONE}\n"
TEST_SKIP=printf "${COLOR_BLUE}$@: ${COLOR_YELLOW}Skipped${COLOR_NONE}\n"
TEST_PASS=printf "${COLOR_BLUE}$@: ${COLOR_GREEN}Passed${COLOR_NONE}\n"
TEST_FAIL=(printf "${COLOR_BLUE}$@: ${COLOR_RED}Failed!${COLOR_NONE}\n" && exit 1)

EXPECT=../../scripts/test-expect.sh
export EXPECTED_PATH=test/expected

CFLAGS_SHARED=-shared
ifneq ($(findstring emcc,$(CC)),) # emcc
  CFLAGS_SHARED=-s SIDE_MODULE=1 -s LINKABLE=1
  INSTALLED_EXTENSION=${BINDIR}/zsvextmy.${SO}
else
  INSTALLED_EXTENSION=
endif

CFLAGS+= -I${THIS_LIB_BASE}/include -I${PREFIX}/include

all: ${TARGET} ${TARGET_SHEET}
	@echo Built ${TARGET}
	@echo Built ${TARGET_SHEET}

ifneq ($(findstring emcc,$(CC)),) # emcc
install: ${INSTALLED_EXTENSION}

${INSTALLED_EXTENSION}: ${TARGET} ${TARGET_SHEET}
	@mkdir -p `dirname "$@"`
	cp -p $< $@
endif

CLI=${BUILD_DIR}/bin/cli${EXE}

RUN_CLI=ZSV_CONFIG_DIR=${TMP_DIR} ${CLI}

${BUILD_DIR}/bin/cli:
	${MAKE} -C .. build-cli CONFIGFILE=${CONFIGFILEPATH} DEBUG=${DEBUG}

${BUILD_DIR}/objs/utils/%.o:
	(cd .. && ${MAKE} CONFIGFILE=${CONFIGFILEPATH} CC=${CC} DEBUG=${DEBUG} $@ )

TESTS=test-1 test-2 test-3 test-4 test-5 test-thirdparty
ifeq ($(ZSVSHEET_BUILD),1)
  TESTS+=test-sheet-extension-1 test-sheet-extension-2
endif

test: ${TESTS}

test-1: test-%: ${CLI} ${TARGET}
	@${TEST_INIT}
	@${RUN_CLI} my-echo < ${THIS_LIB_BASE}/data/quoted.csv > ${TMP_DIR}/zsvext-$@.out
	@${CMP} ${TMP_DIR}/zsvext-$@.out test/expected/zsvext-$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-2: test-%: ${CLI} ${TARGET}
	@${TEST_INIT}
	@${RUN_CLI} my-echo -t < ${THIS_LIB_BASE}/data/hi.txt > ${TMP_DIR}/zsvext-$@.out
	@${CMP} ${TMP_DIR}/zsvext-$@.out test/expected/zsvext-$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-3: test-%: ${CLI} ${TARGET}
	@${TEST_INIT}
	@rm -f ${TMP_DIR}/zsvext-$@.out
	@${RUN_CLI} unregister my 2>/dev/null 1>/dev/null || [ 1==1 ]
	@${RUN_CLI} register my 2>&1 | grep -v [.]${SO} >> ${TMP_DIR}/zsvext-$@.out || [ 1==1 ]
	@${RUN_CLI} unregister my 2>&1 | grep -v [.]${SO} >> ${TMP_DIR}/zsvext-$@.out || [ 1==1 ]
	@${RUN_CLI} unregister my 2>&1 | grep -v [.]${SO} >> ${TMP_DIR}/zsvext-$@.out || [ 1==1 ]
	@${RUN_CLI} help 2>&1 | grep -v [.]${SO} >> ${TMP_DIR}/zsvext-$@.out || [ 1==1 ]
	@${RUN_CLI} register my 2>&1 | grep -v [.]${SO} >> ${TMP_DIR}/zsvext-$@.out || [ 1==1 ]
	@${RUN_CLI} help 2>&1 | grep -v [.]${SO} >> ${TMP_DIR}/zsvext-$@.out || [ 1==1 ]
	@${CMP} ${TMP_DIR}/zsvext-$@.out 2>&1 test/expected/zsvext-$@.out${EXT} && ${TEST_PASS} || ${TEST_FAIL}

test-4: test-%: ${CLI} ${TARGET}
	@${TEST_INIT}
	@${RUN_CLI} unregister my 2>/dev/null 1>/dev/null || [ 1==1 ]
	@${RUN_CLI} license > ${TMP_DIR}/zsvext-$@.out 2>> ${TMP_DIR}/zsvext-$@.err
	@${RUN_CLI} register my 2>/dev/null 1>/dev/null
	@${RUN_CLI} license >> ${TMP_DIR}/zsvext-$@.out 2> ${TMP_DIR}/zsvext-$@.err
	@${CMP} ${TMP_DIR}/zsvext-$@.out test/expected/zsvext-$@.out && ${TEST_PASS} || ${TEST_FAIL}
	@${CMP} ${TMP_DIR}/zsvext-$@.err test/expected/zsvext-$@.err && ${TEST_PASS} || ${TEST_FAIL}

test-5: test-%:${TARGET}
	@${TEST_INIT}
	@${RUN_CLI} my-count newline.csv 2>/dev/null > ${TMP_DIR}/zsvext-$@.out
	@${RUN_CLI} my-count -q newline.csv 2>/dev/null >> ${TMP_DIR}/zsvext-$@.out
	@${CMP} ${TMP_DIR}/zsvext-$@.out test/expected/zsvext-$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-thirdparty: test-%: ${CLI} ${TARGET}
	@${TEST_INIT}
	@${RUN_CLI} unregister my 2>/dev/null 1>/dev/null || [ 1==1 ]
	@${RUN_CLI} thirdparty > ${TMP_DIR}/zsvext-$@.out
	@${RUN_CLI} register my 2>/dev/null 1>/dev/null
	@${RUN_CLI} thirdparty >> ${TMP_DIR}/zsvext-$@.out
	@${CMP} ${TMP_DIR}/zsvext-$@.out test/expected/zsvext-$@.out && ${TEST_PASS} || ${TEST_FAIL}

../test/worldcitiespop_mil.csv:
	make -C ../test worldcitiespop_mil.csv

DATE_TIME:=$(shell date +%F-%H-%M-%S)
export TIMINGS_CSV:=${TMP_DIR}/timings-${DATE_TIME}.csv
TMUX_TERM=xterm-256color
test-sheet-extension-1: ${CLI} ${TARGET} ../test/worldcitiespop_mil.csv
	@${TEST_INIT}
ifeq ($(IS_WSL),1)
	@${TEST_SKIP}
else
	@rm -f ${TMP_DIR}/zsvext-$@.out tmux-*.log
	@tmux kill-session -t $@ || echo 'No tmux session to kill'
	@echo 'set-option default-terminal "${TMUX_TERM}"' > ~/.tmux.conf
	@${RUN_CLI} unregister my 2>/dev/null 1>/dev/null || [ 1==1 ]
	@${RUN_CLI} register my 2>&1 | grep -v [.]${SO} || [ 1==1 ]
	@(ZSV_CONFIG_DIR=${TMP_DIR} tmux -v new-session -x 80 -y 5 -d -s $@ "$< sheet ../test/worldcitiespop_mil.csv" && \
	${EXPECT} $@ indexed && \
	tmux send-keys -t $@ "t" "hello" Enter Up Down && \
	${EXPECT} $@ && ${TEST_PASS} || ${TEST_FAIL})
endif

test-sheet-extension-2: ${CLI} ${TARGET}
	@${TEST_INIT}
ifeq ($(IS_WSL),1)
	@${TEST_SKIP}
else
	@rm -f ${TMP_DIR}/zsvext-$@.out tmux-*.log
	@tmux kill-session -t $@ || echo 'No tmux session to kill'
	@echo 'set-option default-terminal "${TMUX_TERM}"' > ~/.tmux.conf
	@${RUN_CLI} unregister my 2>/dev/null 1>/dev/null || [ 1==1 ]
	@${RUN_CLI} register my 2>&1 | grep -v [.]${SO} || [ 1==1 ]
	@(ZSV_CONFIG_DIR=${TMP_DIR} tmux -v new-session -x 120 -y 5 -d -s $@ "$< sheet -d 3 ../../data/test/mixed-line-endings.csv" && \
	${EXPECT} $@ indexed && \
	tmux send-keys -t $@ "T" && \
	${EXPECT} $@ transformed && \
	tmux send-keys -t $@ "G" && \
	${EXPECT} $@ && ${TEST_PASS} || ${TEST_FAIL})
endif

clean:
	@rm -f ${TARGET} ${TARGET_SHEET} ${TMP_DIR}/zsvext-test*.out

${BUILD_DIR}/objs/%.o : ${THIS_LIB_BASE}/src/%.c ${PARSER_DEPS}
	${MAKE} -C ${THIS_LIB_BASE}/src CONFIGFILE=${CONFIGFILEPATH} DEBUG=${DEBUG} WIN=${WIN} $@

LIBZSV=${PREFIX}/lib/libzsv.a
${LIBZSV}:
	${MAKE} -C ${THIS_LIB_BASE}/src CONFIGFILE=${CONFIGFILEPATH} DEBUG=${DEBUG} WIN=${WIN} install

LIBZSVUTIL=${PREFIX}/lib/libzsvutil.a
${LIBZSVUTIL}:
	${MAKE} -C ${THIS_LIB_BASE}/app CONFIGFILE=${CONFIGFILEPATH} DEBUG=${DEBUG} WIN=${WIN} install-util-lib

YAJL_SRC_DIR=${THIS_MAKEFILE_DIR}/../external/yajl
YAJL_INCLUDE=-I${YAJL_SRC_DIR}/build/yajl-2.1.1/include
YAJL_HELPER_INCLUDE=-I${THIS_MAKEFILE_DIR}/../external/yajl_helper
${TARGET_SHEET}: LIBS="../external/sqlite3/sqlite3.c" -lzsvutil -lzsv -L${PREFIX}/lib -ljq -lutf8proc
${TARGET}: LIBS=-lzsvutil -lzsv -L${PREFIX}/lib
${TARGET} ${TARGET_SHEET}: ${BUILD_DIR}/bin/zsvext%.${SO} : %_extension.c ${LIBZSV} ${LIBZSVUTIL}
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} ${CFLAGS_SHARED} $< -o $@ ${LIBS} ${YAJL_INCLUDE} ${YAJL_HELPER_INCLUDE}

.PHONY: all test test-% clean install ${PREFIX}/lib/libzsvutil.a

=== app/ext_template/Makefile ===
# Copyright (C) zsv contributors. All rights reserved.
#
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))

CONFIGFILE ?= ../../config.mk
$(info Using config file ${CONFIGFILE})
include ${CONFIGFILE}

CC ?= cc

WIN=
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif

ifeq ($(DEBUG),1)
  DBG_SUBDIR+=dbg
else
  DBG_SUBDIR+=rel
endif

ifeq ($(WIN),0)
  BUILD_SUBDIR=$(shell uname)/${DBG_SUBDIR}
  SO=so
  ifeq ($(BUILD_SUBDIR),Linux)
    CFLAGS+= -ldl -lpthread
  endif
  CFLAGS+= -fPIC
else
  BUILD_SUBDIR=win/${DBG_SUBDIR}
  CFLAGS+= -D__USE_MINGW_ANSI_STDIO -D_ISOC99_SOURCE
  CFLAGS+= -Wl,--strip-all
  CFLAGS+= -fpie
  SO=dll
endif

DEBUG=0
ifeq ($(DEBUG),0)
  CFLAGS+= -O3 -DNDEBUG -Wshadow -Wall -Wextra -pedantic -DSTDC_HEADERS -flto
else
  CFLAGS += -g
endif

THIS_LIB_BASE=$(shell cd ../.. && pwd)
CCBN=$(shell basename ${CC})
EXTENSION_ID=xx
BUILD_DIR=${THIS_MAKEFILE_DIR}/build/${BUILD_SUBDIR}/${CCBN}
TARGET=${BUILD_DIR}/bin/zsvext${EXTENSION_ID}.${SO}

UTILS1=
CFLAGS_SHARED=-shared
ifneq ($(findstring emcc,$(CC)),) # emcc
  CFLAGS_SHARED=-s SIDE_MODULE=1
  # add some additional file system support glue
  UTILS1+= emcc/fs_api
endif

UTILS1+= # put any zsv utils here
UTILS=$(addprefix ${BUILD_DIR}/objs/utils/,$(addsuffix .o,${UTILS1}))

CFLAGS+= -I${THIS_LIB_BASE}/include

all: ${TARGET}

# zsv utils
${BUILD_DIR}/objs/utils/%.o:
	(cd .. && ${MAKE} CONFIGFILE=${CONFIGFILEPATH} CC=${CC} DEBUG=${DEBUG} $@ )

install: ${TARGET}
	@echo "To install, copy ${TARGET} to a system path or the same dir"
	@echo "as the zsv binary"

clean:
	@rm -f ${TARGET}

${TARGET}: YOUR_EXTENSION_zsvext.c ${UTILS}
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} ${CFLAGS_SHARED} $< ${UTILS} -o $@

.PHONY: all test clean test-%

=== app/test/Makefile ===
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_DIR:=$(shell basename "${THIS_MAKEFILE_DIR}")
THIS_MAKEFILE:=$(lastword $(MAKEFILE_LIST))

CONFIGFILE ?= ../../config.mk
ifneq ($(QUIET),1)
  $(info # Using config file ${CONFIGFILE})
endif
include ${CONFIGFILE}

CONFIGFILEPATH=$(shell ls ${CONFIGFILE} >/dev/null 2>/dev/null && realpath ${CONFIGFILE})
ifeq ($(CONFIGFILEPATH),)
  $(error Config file ${CONFIGFILE} not found)
endif

CC ?= cc

WIN=
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif

ifeq ($(DEBUG),1)
  DBG_SUBDIR+=dbg
else
  DBG_SUBDIR+=rel
endif

ifeq ($(WIN),0)
  BUILD_SUBDIR=$(shell uname)/${DBG_SUBDIR}
  EXE=
else
  BUILD_SUBDIR=win/${DBG_SUBDIR}
  EXE=.exe
endif

export THIS_LIB_BASE=$(shell cd ../.. && pwd)
CCBN=$(shell basename ${CC})
BUILD_DIR=${THIS_LIB_BASE}/build/${BUILD_SUBDIR}/${CCBN}
export TMP_DIR=${THIS_LIB_BASE}/tmp
TEST_DATA_DIR=${THIS_LIB_BASE}/data

IS_WSL=$(shell grep -qi microsoft /proc/version 2>/dev/null && echo 1 || echo 0)
ifeq ($(IS_WSL),1)
  TEST_DATA_DIR=./../../data
  TMP_DIR=./../../tmp
endif

SOURCES=echo count count-pull select select-pull sql 2json serialize flatten pretty desc stack 2db 2tsv jq compare
ifneq ($(ZSV_EXTRAS),)
  SOURCES+=overwrite
endif
TARGETS=$(addprefix ${BUILD_DIR}/bin/zsv_,$(addsuffix ${EXE},${SOURCES}))

TESTS=test-blank-leading-rows $(addprefix test-,${SOURCES}) test-rm test-mv test-2json-help test-paste test-flatten-2

ifeq ($(ZSVSHEET_BUILD),1)
  SOURCES+=sheet
  CFLAGS+=-DZSVSHEET_BUILD
  CFLAGS+=${CFLAGS_NCURSES}
  LDFLAGS+=${LDFLAGS_NCURSES}
  TESTS+=test-sheet test-sheet-subcommand
endif

ifneq ($(ZSV_NO_PARALLEL),1)
  TESTS+=test-parallel
endif
TESTS+=test-check

COLOR_NONE=\033[0m
COLOR_GREEN=\033[1;32m
COLOR_RED=\033[1;31m
COLOR_BLUE=\033[1;34m
COLOR_PINK=\033[1;35m
COLOR_YELLOW=\033[1;33m

TEST_INIT=mkdir -p ${TMP_DIR} && printf "${COLOR_PINK}$@: ${COLOR_NONE}\n"
TEST_SKIP=printf "${COLOR_BLUE}$@: ${COLOR_YELLOW}Skipped${COLOR_NONE}\n"
TEST_PASS=printf "${COLOR_BLUE}$@: ${COLOR_GREEN}Passed${COLOR_NONE}\n"
TEST_FAIL=(printf "${COLOR_BLUE}$@: ${COLOR_RED}Failed!${COLOR_NONE}\n" && exit 1)

ARGS-sql='select [Loan Number] from data'

LEAKS=
ifneq ($(LEAKS),)
  PREFIX=leaks 2>/dev/null --atExit --
  REDIRECT=>${TMP_DIR}/leaks.txt; grep leak ${TMP_DIR}/leaks.txt | grep bytes \# # stop processing at this step
  REDIRECT1=>${TMP_DIR}/leaks.txt; grep leak ${TMP_DIR}/leaks.txt | grep bytes ) \# # stop processing at this step
  REDIRECT2=>${TMP_DIR}/leaks.txt; grep leak ${TMP_DIR}/leaks.txt | grep bytes ) \# # stop processing at this step
  export CMP=\# # don't run this step
else
  PREFIX=
  REDIRECT=>
  REDIRECT1=>
  REDIRECT2=-o
  export CMP=cmp
endif

BIG_FILE ?= none
EXPECT_TIMEOUT ?= 5
EXPECT=../../scripts/test-expect.sh
export EXPECTED_PATH=expected

MAKE_BIN=$(notdir ${MAKE})

DATE_TIME:=$(shell date +%F-%H-%M-%S)
export TIMINGS_CSV:=${TMP_DIR}/timings-${DATE_TIME}.csv

help:
	@echo "To run all tests: ${MAKE_BIN} test [LEAKS=1]"
	@echo "To run individual test: ${MAKE_BIN} test-xxx"
	@echo "To run on cli: ${MAKE_BIN} CLI"
	@echo "  where xxx can be: blank-leading-rows ${SOURCES}"

clean:
	rm -rf ${TMP_DIR}

CLI:
	@echo "Testing CLI..."
	@${MAKE} CLI1=1 test -n | sed 's/\/[^ ]*\/bin\/zsv_/zsv /g' | sh

test: ${TESTS}

test-paste:
	@echo "TO DO: test paste"

${TIMINGS_CSV}:
	@mkdir -p ${TMP_DIR}
	@echo -n "Test, Stage, Time" > ${TIMINGS_CSV}

.SECONDARY: worldcitiespop_mil.csv

.PHONY: help test test-% test-stack clean

test-prop:
	@${TEST_INIT}
	@EXE=${BUILD_DIR}/bin/zsv_prop${EXE} ${MAKE} -C prop test

ifneq ($(ZSV_NO_PARALLEL),1)
test-parallel: ${BUILD_DIR}/bin/zsv_select${EXE} ${BUILD_DIR}/bin/zsv_count${EXE} worldcitiespop_mil.csv
	@${TEST_INIT}
	@SELECT_EXE=${BUILD_DIR}/bin/zsv_select${EXE} COUNT_EXE=${BUILD_DIR}/bin/zsv_count${EXE} ${MAKE} -C parallel test
endif

test-check: test-check-1 test-check-2

test-check-1: ${BUILD_DIR}/bin/zsv_check${EXE}
	@${TEST_INIT}
	@$< ${TEST_DATA_DIR}/test/check.csv -o ${TMP_DIR}/$@.out1 && (echo "should have failed!") || [ 1 = 1 ]
	@cmp ${TMP_DIR}/$@.out1 expected/$@.out1 && ${TEST_PASS} || ${TEST_FAIL}
	@$< ${TEST_DATA_DIR}/test/check.csv --display-row -o ${TMP_DIR}/$@.out2 && (echo "should have failed!" && exit 1) || [ 1 = 1 ]
	@cmp ${TMP_DIR}/$@.out2 expected/$@.out2 && ${TEST_PASS} || ${TEST_FAIL}

test-check-2: ${BUILD_DIR}/bin/zsv_check${EXE}
	@${TEST_INIT}
	@$< --display-row ${TEST_DATA_DIR}/test/latin1.csv -o ${TMP_DIR}/$@.out && (echo "should have failed!") || [ 1 = 1 ]
	@cmp ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-overwrite: ${BUILD_DIR}/bin/zsv_overwrite${EXE} ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
ifeq ($(IS_WSL),1)
	@${TEST_SKIP}
else
	@EXE=${BUILD_DIR}/bin/zsv_overwrite${EXE} ECHO_EXE=${BUILD_DIR}/bin/zsv_echo${EXE} CMP="${CMP}" ${MAKE} -C overwrite test
endif

test-echo: \
	test-echo1 test-echo-overwrite-all test-echo-eol test-echo-chars test-echo-trim \
	test-echo-skip-until test-echo-contiguous test-echo-trim-columns test-echo-trim-columns-2 test-echo-buffsize \
	test-echo-quoted test-echo-rows

test-echo-rows: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< ${TEST_DATA_DIR}/test/6x3.csv --start-row 3 ${REDIRECT} ${TMP_DIR}/$@.out1
	@${CMP} ${TMP_DIR}/$@.out1 expected/$@.out1 && ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} $< ${TEST_DATA_DIR}/test/6x3.csv --end-row 3 ${REDIRECT} ${TMP_DIR}/$@.out2
	@${CMP} ${TMP_DIR}/$@.out2 expected/$@.out2 && ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} $< ${TEST_DATA_DIR}/test/6x3.csv --between-row 2 4 ${REDIRECT} ${TMP_DIR}/$@.out3
	@${CMP} ${TMP_DIR}/$@.out3 expected/$@.out3 && ${TEST_PASS} || ${TEST_FAIL}

test-echo-overwrite-all: test-echo-overwrite test-echo-overwrite-csv test-echo-overwrite-auto

test-echo1: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< ${TEST_DATA_DIR}/loans_1.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-eol: test-echo-eol-1 test-echo-eol-2 test-echo-eol-3 test-echo-eol-4

test-echo-eol-%: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< ${TEST_DATA_DIR}/test/no-eol-$*.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-trim: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< --trim ${TEST_DATA_DIR}/test/echo-trim.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-skip-until: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< --skip-until ASF ${TEST_DATA_DIR}/test/echo-skip-until.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-contiguous: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< --contiguous ${TEST_DATA_DIR}/test/../../data/test/echo-contiguous.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-trim-columns: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< --trim-columns ${TEST_DATA_DIR}/test/echo-trim-columns.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-trim-columns-2: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< --trim --trim-columns ${TEST_DATA_DIR}/test/echo-trim-columns.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-quoted: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} $< ${TEST_DATA_DIR}/test/echo-quoted.csv ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-buffsize: ${BUILD_DIR}/bin/zsv_echo${EXE} ${TEST_DATA_DIR}/bigger-than-buff.csv
	@${TEST_INIT}
	@${PREFIX} $< ${TEST_DATA_DIR}/bigger-than-buff.csv --buff-size 131072 ${REDIRECT} ${TMP_DIR}/$@.out 2> ${TMP_DIR}/$@.err
	@(${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${CMP} ${TMP_DIR}/$@.err expected/$@.err) && ${TEST_PASS} || ${TEST_FAIL}

test-echo-chars: ${BUILD_DIR}/bin/zsv_echo${EXE}
	@${TEST_INIT}
	@${PREFIX} echo '東京都' | $< -u '?' ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-echo-overwrite: ${BUILD_DIR}/bin/zsv_echo${EXE}
ifneq ($(ZSV_EXTRAS),)
	@${TEST_INIT}
	@${PREFIX} $< ${TEST_DATA_DIR}/loans_1.csv --overwrite 'sqlite3://${TEST_DATA_DIR}/loans_1-overwrite.db?sql=select row,col,value from overwrites order by row,col' ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}
endif

test-echo-overwrite-auto: ${BUILD_DIR}/bin/zsv_echo${EXE}
ifneq ($(ZSV_EXTRAS),)
	@${TEST_INIT}
	@rm -f ${TEST_DATA_DIR}/.zsv/data/loans_2.csv/overwrite.sqlite3
	@cp -p ${TEST_DATA_DIR}/loans_1.csv ${TEST_DATA_DIR}/loans_2.csv
	@${PREFIX} $< ${TEST_DATA_DIR}/loans_2.csv ${REDIRECT} ${TMP_DIR}/$@-before.out
	@${CMP} ${TMP_DIR}/$@-before.out expected/$@-before.out && ${TEST_PASS} || ${TEST_FAIL}
	@mkdir -p ${TEST_DATA_DIR}/.zsv/data/loans_2.csv
	@sqlite3 ${TEST_DATA_DIR}/.zsv/data/loans_2.csv/overwrite.sqlite3 < ${TEST_DATA_DIR}/loans_2_overwrite.sql
	@${PREFIX} $< ${TEST_DATA_DIR}/loans_2.csv ${REDIRECT} ${TMP_DIR}/$@-after-ignored.out
	@${CMP} ${TMP_DIR}/$@-after-ignored.out expected/$@-after-ignored.out && ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} $< ${TEST_DATA_DIR}/loans_2.csv --apply-overwrites ${REDIRECT} ${TMP_DIR}/$@-after-applied.out
	@${CMP} ${TMP_DIR}/$@-after-applied.out expected/$@-after-applied.out && ${TEST_PASS} || ${TEST_FAIL}
endif

test-echo-overwrite-csv: ${BUILD_DIR}/bin/zsv_echo${EXE} ${TEST_DATA_DIR}/loans_1-overwrite.csv
ifneq ($(ZSV_EXTRAS),)
	@${TEST_INIT}
	@${PREFIX} $< ${TEST_DATA_DIR}/loans_1.csv --overwrite '${TEST_DATA_DIR}/loans_1-overwrite.csv' ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}
endif

worldcitiespop_mil.csv:
	curl -LOk 'https://burntsushi.net/stuff/worldcitiespop_mil.csv'

worldcitiespop_mil.tsv: worldcitiespop_mil.csv ${BUILD_DIR}/bin/zsv_2tsv${EXE}
	@${BUILD_DIR}/bin/zsv_2tsv${EXE} $< > $@

test-count test-count-pull: test-% : test-1-% test-2-%

ifeq ($(ZSV_NO_PARALLEL),1)
ifeq ($(HAVE_PCRE2_8),1)
  HELP_SELECT_LINES=40
  HELP_COUNT_LINES=6
else
  HELP_SELECT_LINES=39
  HELP_COUNT_LINES=6
endif
else
ifeq ($(HAVE_PCRE2_8),1)
  HELP_SELECT_LINES=43
  HELP_COUNT_LINES=8
else
  HELP_SELECT_LINES=42
  HELP_COUNT_LINES=8
endif
endif
test-cli: ${CLI}
	@${TEST_INIT}
	@[ "${CLI}" = "" ] && echo 1>&2 'test-cli: missing CLI env var' && exit 1 || exit 0
	@$< help select 2>&1 > ${TMP_DIR}/$@.out
	@[ "`head -1 ${TMP_DIR}/$@.out | tr -d '\r\n'`" = "select: extracts and outputs specified columns" ] && [ $$(( `cat ${TMP_DIR}/$@.out | wc -l` )) = "${HELP_SELECT_LINES}" ] && ${TEST_PASS} || ${TEST_FAIL}
	@$< help count 2>&1 > ${TMP_DIR}/$@.out
	@[ "`head -1 ${TMP_DIR}/$@.out | tr -d '\r\n'`" = "Usage: count [options]" ] && [ $$(( `cat ${TMP_DIR}/$@.out | wc -l` )) = "${HELP_COUNT_LINES}" ] && ${TEST_PASS} || ${TEST_FAIL}

test-1-count test-1-count-pull: test-1-% : ${BUILD_DIR}/bin/zsv_%${EXE} worldcitiespop_mil.csv
	@${TEST_INIT}
	@cat worldcitiespop_mil.csv | ${PREFIX} $< ${REDIRECT} ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/test-1-count.out && ${TEST_PASS} || ${TEST_FAIL}

test-2-count test-2-count-pull: ${BUILD_DIR}/bin/zsv_count${EXE} ${TEST_DATA_DIR}/test/buffsplit_quote.csv
	@${TEST_INIT}
	@for x in 5000 5002 5004 5006 5008 5010 5013 5015 5017 5019 5021 5101 5105 5111 5113 5115 5117 5119 5121 5123 5125 5127 5129 5131 5211 5213 5215 5217 5311 5313 5315 5317 5413 5431 5433 5455 6133 ; do $< -r $$x ${TEST_DATA_DIR}/test/buffsplit_quote.csv ; done > ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/test-2-count.out && ${TEST_PASS} || ${TEST_FAIL}

=== examples/js/Makefile ===
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_MAKEFILE:=$(lastword $(MAKEFILE_LIST))

CC ?= emcc
SED ?= sed
NODE_PKG_NAME=zsv-lib

CONFIGFILE= ${THIS_MAKEFILE_DIR}/../../config.emcc
$(info Using config file ${CONFIGFILE})
include ${CONFIGFILE}
CONFIGFILEPATH=$(shell ls ${CONFIGFILE} >/dev/null 2>/dev/null && realpath ${CONFIGFILE})
ifeq ($(CONFIGFILEPATH),)
  $(error Config file ${CONFIGFILE} not found)
endif

ifeq ($(findstring emcc,$(CC)),) # emcc
  $(error Please use emcc to compile)
endif

ZSVSRC1=zsv.c ../app/utils/string.c
ZSVSRCDIR=${THIS_MAKEFILE_DIR}/../../src
ZSVSRC=$(addprefix ${ZSVSRCDIR}/,${ZSVSRC1})

INCLUDE_DIR=${THIS_MAKEFILE_DIR}/../../include

CFLAGS += -I../../app/external/utf8proc-2.6.1 # for app/utils/string.c
CFLAGS += -I../../app/external/sqlite3

ifeq ($(DEBUG),1)
  DBG_SUBDIR+=dbg
else
  DBG_SUBDIR+=rel
endif

CCBN=$(shell basename ${CC})
BUILD_DIR=${THIS_MAKEFILE_DIR}/build/${DBG_SUBDIR}/${CCBN}

BROWSER_JS=${BUILD_DIR}/zsv.js
INDEX=${BUILD_DIR}/index.html
EMJS=${BUILD_DIR}/zsv.em.js
WASM=${BUILD_DIR}/zsv.em.wasm

CFLAGS+= ${CFLAGS_PIC} -s ALLOW_MEMORY_GROWTH=1 -s EXPORTED_RUNTIME_METHODS="['setValue','addFunction','removeFunction','writeArrayToMemory']" -s RESERVED_FUNCTION_POINTERS=4 -s EXPORTED_FUNCTIONS="['_free','_malloc']" -sASSERTIONS

ifeq ($(DEBUG),1)
  CFLAGS += ${CFLAGS_DEBUG}
else
  CFLAGS+= -O3 -DNDEBUG #  -std=gnu11 -Wno-gnu-statement-expression -Wshadow -Wall -Wextra -Wno-missing-braces -pedantic -DSTDC_HEADERS -D_GNU_SOURCE -lm -mavx2 -ftree-vectorize -flto
endif

BROWSER_STATIC=${BUILD_DIR}/index.html ${BUILD_DIR}/zsv-browser-example.js
OTHERUTIL=${BUILD_DIR}/localhost.pem
STATIC=${BROWSER_STATIC} ${OTHERUTIL}

##### test-related definitions
COLOR_NONE=\033[0m
COLOR_GREEN=\033[1;32m
COLOR_RED=\033[1;31m
COLOR_BLUE=\033[1;34m
COLOR_PINK=\033[1;35m

TEST_PASS=printf "${COLOR_BLUE}$@: ${COLOR_GREEN}Passed${COLOR_NONE}\n"
TEST_FAIL=(printf "${COLOR_BLUE}$@: ${COLOR_RED}Failed!${COLOR_NONE}\n" && exit 1)
#####

.PHONY: help all run clean prep node setup benchmark count_compare select_compare node_ok

help:
	@echo "make [build|run|node|test|clean] [NODE=/path/to/node]" # e.g. NODE=/usr/local/Cellar/node/19.1.0/bin/node
	@echo "by default, minified code is generated, which requires running the below once:"
	@echo "  make setup"
	@echo "alternatively, to generate non-minified code, use NO_MINIFY=1:"
	@echo "  make NO_MINIFY=1 [build|run|node|test|benchmark]"

build: ${BROWSER_JS} ${STATIC}
	@echo Built ${BROWSER_JS}

run: ${BROWSER_JS} ${STATIC}
	cd ${BUILD_DIR} && ${THIS_MAKEFILE_DIR}/browser/util/http-dev.py

clean:
	rm -rf build node

prep: utf8proc.h zsv.h

zsv.h:
	make -C ../../src ../include/zsv.h

utf8proc.h:
	make -C ../../app ./external/utf8proc-2.6.1/utf8proc.h THIS_MAKEFILE_DIR=.

test: node_ok npm/test/select_all.js node
	@mkdir -p build/test
	@cp -p npm/test/select_all.js node/
	@echo "Running test (example) program \`node node/select_all.js ../../data/test/desc.csv\`"
	@(cd node && ${NODE} select_all.js ../../../data/test/desc.csv > ../build/test/out.json 2> ../build/test/out.err1)
	@sed 's/[0-9.]*ms//g' < build/test/out.err1 > build/test/out.err
	@cmp build/test/out.err npm/test/out.err
	@cmp build/test/out.json npm/test/out.json && ${TEST_PASS} || ${TEST_FAIL}

${BROWSER_STATIC}: ${BUILD_DIR}/% : browser/%
	@mkdir -p `dirname "$@"`
	@cp -p $< $@

${OTHERUTIL}: ${BUILD_DIR}/% : browser/util/%
	@mkdir -p `dirname "$@"`
	@cp -p $< $@

${EMJS}: ${ZSVSRC} zsv_parser_api_dummy.c
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -I${INCLUDE_DIR} $^ -o $@

${WASM}: ${EMJS}

${BUILD_DIR}/zsv-browser-example.js:

${BROWSER_JS}: prep ${EMJS} js/head.js js/foot.js
	@mkdir -p `dirname "$@"`
	@cat js/head.js > $@.tmp.js
	@cat ${EMJS} >> $@.tmp.js
	@cat js/foot.js >> $@.tmp.js
ifeq ($(NO_MINIFY),1)
	@mv $@.tmp.js $@
else
	@uglifyjs $@.tmp.js -c -m > $@
	rm $@.tmp.js
endif

### node package build
NODE_INDEX=node/node_modules/${NODE_PKG_NAME}/index.js
NODE_WASM=node/node_modules/${NODE_PKG_NAME}/zsv.em.wasm
${NODE_WASM}: ${WASM}
	@mkdir -p `dirname "$@"`
	@cp -p $< $@

NODE_PKG_FILES=$(addprefix node/node_modules/${NODE_PKG_NAME}/, package.json README.md)
${NODE_PKG_FILES}: node/node_modules/${NODE_PKG_NAME}/% : npm/%
	@mkdir -p `dirname "$@"`
	@cp -p $< $@

${NODE_INDEX}: ${BROWSER_JS} js/foot_node.js
	@mkdir -p `dirname "$@"`
	@cat $^ > $@.tmp.js
ifeq ($(NO_MINIFY),1)
	@mv $@.tmp.js $@
else
	@uglifyjs $@.tmp.js -c -m > $@
	rm $@.tmp.js
endif

setup:
	npm install -g uglify-es

node: ${NODE_WASM} ${NODE_INDEX} ${NODE_PKG_FILES}
	@echo "Built node module in node/node_modules/${NODE_PKG_NAME}"


#### node benchmark
BENCHMARK_INPUT=${THIS_MAKEFILE_DIR}/../../app/benchmark/worldcitiespop_mil.csv

NODE=node --experimental-wasm-modules

NODE_VERSION=$(shell ${NODE} --version | sed 's/[.].*$$//' | sed 's/v//')
NODE_OK=$(shell [ "0${NODE_VERSION}" -gt "14" ] && echo "1" || echo "0")

node_ok:
ifneq ($(NODE_OK),1)
	echo "Node version must be at least 15"
	exit 1
endif

benchmark: node_ok node count_compare select_compare

count_compare: node_ok
	@cp -p npm/test/count*.js node/
	@cd node && (npm list | grep csv-parser) && echo "csv-parser already installed" || npm install csv-parser papaparse

	@echo "zsv count"
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count.js 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count.js 2>&1 | head -1


	@echo "csv-parser count"
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count-csv-parser.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count-csv-parser.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count-csv-parser.js 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count-csv-parser.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count-csv-parser.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count-csv-parser.js 2>&1 | head -1

	@echo "papaparse count"
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count-papaparse.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count-papaparse.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/count-papaparse.js 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count-papaparse.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count-papaparse.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/count-papaparse.js 2>&1 | head -1

select_compare: node_ok
	@cp -p npm/test/select_all*.js node/
	@cd node && (npm list | grep csv-parser) && echo "csv-parser already installed" || npm install csv-parser papaparse

	@echo "zsv select_all"
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js '' '[0,2]' 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js '' '[0,2]' 2>&1 | head -1

	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js '' '[0,2]' 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js '' '[0,2]' 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all.js 2>&1 | head -1

	@echo "csv-parser select_all"
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js '' '[0,2]' 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js '' '[0,2]' 2>&1 | head -1

	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js '' '[0,2]' 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js '' '[0,2]' 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-csv-parser.js 2>&1 | head -1

	@echo "papaparse select_all"
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js '' '[0,2]' 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js '' '[0,2]' 2>&1 | head -1

	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js 2>&1 | head -1
	head -5000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js '' '[0,2]' 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js '' '[0,2]' 2>&1 | head -1

	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js 2>&1 | head -1
	head -500000 ${BENCHMARK_INPUT} | ${NODE} node/select_all-papaparse.js 2>&1 | head -1

=== examples/lib/Makefile ===
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_DIR:=$(shell basename "${THIS_MAKEFILE_DIR}")
THIS_MAKEFILE:=$(lastword $(MAKEFILE_LIST))

CONFIGFILE ?= ../../config.mk
include ${CONFIGFILE}

CONFIGFILEPATH=$(shell ls ${CONFIGFILE} >/dev/null 2>/dev/null && realpath ${CONFIGFILE})
ifeq (${CONFIGFILEPATH},)
  $(error Config file ${CONFIGFILE} not found)
endif

ifeq ($(MAKE),)
  MAKE=make
endif

CFLAGS+= -I${PREFIX}/include
ifeq ($(ZSV_EXTRAS),1)
  CFLAGS+= -DZSV_EXTRAS
endif

WIN=
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif

TEST_DATA_DIR=./../../data
TMP_DIR=/tmp
COLOR_NONE=\033[0m
COLOR_GREEN=\033[1;32m
COLOR_RED=\033[1;31m
COLOR_BLUE=\033[1;34m
COLOR_PINK=\033[1;35m
COLOR_YELLOW=\033[1;33m

TEST_INIT=printf "${COLOR_PINK}$@: ${COLOR_NONE}\n"
TEST_SKIP=printf "${COLOR_BLUE}$@: ${COLOR_YELLOW}Skipped${COLOR_NONE}\n"
TEST_PASS=printf "${COLOR_BLUE}$@: ${COLOR_GREEN}Passed${COLOR_NONE}\n"
TEST_FAIL=(printf "${COLOR_BLUE}$@: ${COLOR_RED}Failed!${COLOR_NONE}\n" && exit 1)

EXE=
ifeq ($(WIN),1)
  EXE=.exe
endif

CFLAGS+=-g -O0

BUILD_DIR=build
LIBS+=-lzsv

help:
	@echo "**** Examples using libzsv ****"
	@echo
	@echo "Dependencies:"
	@echo "  - libzsv must already be installed (for more info, \`cd ../.. && ${MAKE}\`)"
	@echo "  - configuration file must be available (to generate, \`cd ../.. && ./configure\`)"
	@echo
	@echo "To build and test using the default configuration:"
	@echo "  ${MAKE} build test"
	@echo
	@echo "To build using a specified configuration:"
	@echo "  ${MAKE} CONFIGFILE=/path/to/config.mk build"
	@echo
	@echo "To build a specific example:"
	@echo "  ${MAKE} simple|print_my_column|parse_by_chunk|pull"
	@echo
	@echo "To remove all build files:"
	@echo "  ${MAKE} clean"
	@echo

build: simple print_my_column parse_by_chunk pull

test: test-eol test-tiny

test-tiny: build/simple${EXE}
	@${TEST_INIT}
	@[ "`echo '' | $< - 2>&1`" = "" ] && ${TEST_PASS} || ${TEST_FAIL}

test-eol: test-eol-1 test-eol-2 test-eol-3 test-eol-4

test-eol-%: ${BUILD_DIR}/simple${EXE} ${BUILD_DIR}/pull${EXE}
	@${TEST_INIT}
	@${BUILD_DIR}/simple${EXE} ${TEST_DATA_DIR}/test/no-eol-$*.csv > ${TMP_DIR}/$@.out
	@cmp ${TMP_DIR}/$@.out test/expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

	@${BUILD_DIR}/pull${EXE} ${TEST_DATA_DIR}/test/no-eol-$*.csv > ${TMP_DIR}/$@.out
	@cmp ${TMP_DIR}/$@.out test/expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

simple print_my_column parse_by_chunk pull: % : ${BUILD_DIR}/%${EXE}
	@echo Built $<

${BUILD_DIR}/print_my_column${EXE} ${BUILD_DIR}/simple${EXE} ${BUILD_DIR}/parse_by_chunk${EXE} ${BUILD_DIR}/pull${EXE}: ${BUILD_DIR}/%${EXE} : %.c
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -o $@ $< ${LIBS} -L${LIBDIR}

clean:
	@rm -rf ${BUILD_DIR}

.PHONY: help build clean simple print_my_column parse_by_chunk pull

=== app/external/memfile-1.0/Makefile ===
# Makefile for use with GNU make

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_DIR:=$(shell basename "${THIS_MAKEFILE_DIR}")
THIS_MAKEFILE:=$(lastword $(MAKEFILE_LIST))

.POSIX:
.SUFFIXES:
.SUFFIXES: .o .c .a

CONFIGFILE ?= config.mk
$(info Using config file ${CONFIGFILE})
include ${CONFIGFILE}

CC ?= cc
AWK ?= awk
AR ?= ar
RANLIB ?= ranlib
SED ?= sed

WIN=
DEBUG=0
ifeq ($(WIN),)
  WIN=0
  ifneq ($(findstring w64,$(CC)),) # e.g. mingw64
    WIN=1
  endif
endif

CFLAGS+=${CFLAG_O} ${CFLAGS_OPT}
CFLAGS+=${CFLAGS_AUTO}
CFLAGS+=-I.

ifeq ($(VERBOSE),1)
  CFLAGS+= ${CFLAGS_VECTORIZE_OPTIMIZED} ${CFLAGS_VECTORIZE_MISSED} ${CFLAGS_VECTORIZE_ALL}
endif

VERSION= $(shell (git describe --always --dirty --tags 2>/dev/null || echo "v0.0.0-memfile") | sed 's/^v//')

ifneq ($(findstring emcc,$(CC)),) # emcc
  NO_THREADING=1
endif

ifeq ($(NO_THREADING),1)
  CFLAGS+= -DNO_THREADING
endif

ifeq ($(DEBUG),0)
  CFLAGS+= -DNDEBUG -O3  ${CFLAGS_LTO}
else
  CFLAGS += ${CFLAGS_DEBUG}
endif

ifeq ($(DEBUG),1)
  DBG_SUBDIR+=dbg
else
  DBG_SUBDIR+=rel
endif

ifeq ($(WIN),0)
  BUILD_SUBDIR=$(shell uname)/${DBG_SUBDIR}
  WHICH=which
  EXE=
  CFLAGS+= -fPIC
else
  BUILD_SUBDIR=win/${DBG_SUBDIR}
  WHICH=where
  EXE=.exe
  CFLAGS+= -fpie
  CFLAGS+= -D__USE_MINGW_ANSI_STDIO -D_ISOC99_SOURCE -Wl,--strip-all
endif

CFLAGS+= -std=gnu11 -Wno-gnu-statement-expression -Wshadow -Wall -Wextra -Wno-missing-braces -pedantic -D_GNU_SOURCE

CFLAGS+= ${MEMFILE_OPTIONAL_CFLAGS}

CCBN=$(shell basename ${CC})
THIS_LIB_BASE=$(shell cd .. && pwd)
INCLUDE_DIR=${THIS_LIB_BASE}/include
BUILD_DIR=${THIS_LIB_BASE}/build/${BUILD_SUBDIR}/${CCBN}

LIB_SUFFIX?=
MEMFILE_OBJ=${BUILD_DIR}/objs/memfile.o
LIBMEMFILE_A=libmemfile${LIB_SUFFIX}.a
LIBMEMFILE=${BUILD_DIR}/lib/${LIBMEMFILE_A}
LIBMEMFILE_INSTALL=${LIBDIR}/${LIBMEMFILE_A}

MEMFILE_OBJ_OPTS=

help:
	@echo "Make options:"
	@echo "  `basename ${MAKE}` build|install|uninstall|clean"
	@echo
	@echo "Optional make variables:"
	@echo "  [CONFIGFILE=config.mk] [VERBOSE=1] [LIBDIR=${LIBDIR}] [INCLUDEDIR=${INCLUDEDIR}] [LIB_SUFFIX=]"
	@echo

build: ${LIBMEMFILE}

${LIBMEMFILE}: ${MEMFILE_OBJ}
	@mkdir -p `dirname "$@"`
	@rm -f $@
	$(AR) rcv $@ $?
	$(RANLIB) $@
	$(AR) -t $@ # check it is there
	@echo Built $@

install: ${LIBMEMFILE_INSTALL}
	@mkdir -p  $(INCLUDEDIR)
	@cp -pR include/*.h $(INCLUDEDIR)
	@echo "include files copied to $(INCLUDEDIR)"

${LIBMEMFILE_INSTALL}: ${LIBMEMFILE}
	@mkdir -p `dirname "$@"`
	@cp -p ${LIBMEMFILE} "$@"
	@echo "libmemfile installed to $@"

uninstall:
	@rm -rf ${INCLUDEDIR}/memfile*
	 rm  -f ${LIBDIR}/libmemfile*

clean:
	rm -rf ${BUILD_DIR}/objs ${LIBMEMFILE}

.PHONY: build install uninstall clean  ${LIBMEMFILE_INSTALL}

${BUILD_DIR}/objs/memfile.o: src/memfile.c include/memfile.h
	@mkdir -p `dirname "$@"`
	${CC} ${CFLAGS} -DMEMFILE_VERSION=\"${VERSION}\" -I${INCLUDE_DIR} ${MEMFILE_OBJ_OPTS} -o $@ -c $<

=== app/test/overwrite/Makefile ===
## Copyright (C) 2022 Guarnerix Inc dba Liquidaty - All Rights Reserved
## Unauthorized copying of this file, via any medium is strictly prohibited
## Proprietary and confidential
##

THIS_MAKEFILE_DIR:=$(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
THIS_MAKEFILE := $(lastword $(MAKEFILE_LIST))

### helper funcs
COLOR_NONE=\033[0m
COLOR_GREEN=\033[1;32m
COLOR_RED=\033[1;31m
COLOR_BLUE=\033[1;34m
COLOR_PINK=\033[1;35m
COLOR_YELLOW=\033[1;33m

TMP_DIR=${THIS_MAKEFILE_DIR}/tmp

TEST_INIT=mkdir -p ${TMP_DIR} && rm -rf ${TMP_DIR}/test* && printf "${COLOR_PINK}test-overwrite-$@: ${COLOR_NONE}\n"
TEST_SKIP=printf "${COLOR_BLUE}$@: ${COLOR_YELLOW}Skipped${COLOR_NONE}\n"
TEST_PASS=printf "${COLOR_BLUE}$@: ${COLOR_GREEN}Passed${COLOR_NONE}\n"
TEST_FAIL=(printf "${COLOR_BLUE}$@: ${COLOR_RED}Failed!${COLOR_NONE}\n" && exit 1)

LEAKS=
ifneq ($(LEAKS),)
  PREFIX=leaks 2>/dev/null --atExit --
  SUFFIX=>${TMP_DIR}/leaks.txt; grep leak ${TMP_DIR}/leaks.txt | grep bytes \# # stop processing at this step
  CHECK=\# # don't run this step
else
  PREFIX=
  SUFFIX=>${TMP_DIR}/$@.out
  CHECK=
endif

help:
	@echo "# run all tests:"
	@echo "    make test"

ifeq ($(EXE),)
  $(error EXE is not defined)
endif

test: \
	test-1 test-2 test-excel-cells test-add test-remove test-old-value test-force \
	test-bulk-add test-bulk-remove test-echo-overwrite-auto test-timestamp

test-1:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy.csv clear
	@${CHECK} [ "`${EXE} dummy.csv list`" = "row,column,value,timestamp,author" ] && ${TEST_PASS} || ${TEST_FAIL}

TIMESTAMP=$(shell date +"%s")
HEADER=row,column,value,timestamp,author

test-2:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy.csv clear
	@${PREFIX} ${EXE} dummy.csv add 2-1 ABC --no-timestamp
	@${CHECK} [ "`${EXE} dummy.csv list`" = "`printf \"$(HEADER)\n2,1,ABC,,\n\"`" ] && ${TEST_PASS} || ${TEST_FAIL}

test-excel-cells:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy.csv clear
	@${PREFIX} ${EXE} dummy.csv add C2 EXCEL --no-timestamp
	@${CHECK} [ "`${EXE} dummy.csv list`" = "`printf \"$(HEADER)\n1,2,EXCEL,,\n\"`" ] && ${TEST_PASS} || ${TEST_FAIL}
	@${CHECK} [ "`${EXE} dummy.csv list --A1`" = "`printf \"$(HEADER)\nC2,EXCEL,,\n\"`" ] && ${TEST_PASS} || ${TEST_FAIL}

test-add:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy2.csv clear
	@${PREFIX} ${EXE} dummy2.csv add 1-2 VAL1 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-2 VAL2 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-3 VAL3 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-4 VAL4 --no-timestamp
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,2,VAL1,,\n2,2,VAL2,,\n2,3,VAL3,,\n2,4,VAL4,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} ${ECHO_EXE} --apply-overwrites dummy2.csv > ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

test-remove:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy2.csv clear
	@${PREFIX} ${EXE} dummy2.csv add 1-1 V1 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-1 V2 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 3-1 V3 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 4-1 V4 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv remove 2-1
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,1,V1,,\n3,1,V3,,\n4,1,V4,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} ${EXE} dummy2.csv remove 4-1
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,1,V1,,\n3,1,V3,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} ${EXE} dummy2.csv remove --all
	@${CHECK} [ ! -f ".zsv/overwrite/dummy2.csv/overwrite.sqlite3" ] \
			&& ${TEST_PASS} || ${TEST_FAIL}

test-old-value:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy2.csv clear
	@${PREFIX} ${EXE} dummy2.csv add 1-1 V1 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-1 V2 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 3-1 V3 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 4-1 V4 --no-timestamp
	@${CHECK} [ "`printf \"$$(${PREFIX} ${EXE} dummy2.csv add 3-1 NEW_V4 --no-timestamp 2>&1)\"`" = "`cat expected/$@-fail.out`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} ${EXE} dummy2.csv remove 2-1 --old-value V3
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,1,V1,,\n2,1,V2,,\n3,1,V3,,\n4,1,V4,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} ${EXE} dummy2.csv add 2-1 NEW_V2 --old-value V2 --no-timestamp
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,1,V1,,\n2,1,NEW_V2,,\n3,1,V3,,\n4,1,V4,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} ${EXE} dummy2.csv remove 3-1 --old-value V3
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,1,V1,,\n2,1,NEW_V2,,\n4,1,V4,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}

test-force:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy2.csv clear
	@${PREFIX} ${EXE} dummy2.csv add 1-2 VAL1 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-2 VAL2 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-3 VAL3 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv add 2-4 VAL4 --no-timestamp
	@${CHECK} [ "`printf \"$$(${PREFIX} ${EXE} dummy2.csv add 2-4 NEW_VAL4 --no-timestamp 2>&1)\"`" = "`cat expected/$@-fail.out`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,2,VAL1,,\n2,2,VAL2,,\n2,3,VAL3,,\n2,4,VAL4,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}
	@${PREFIX} ${EXE} dummy2.csv add 2-4 NEW_VAL4 --no-timestamp --force
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,2,VAL1,,\n2,2,VAL2,,\n2,3,VAL3,,\n2,4,NEW_VAL4,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}

test-bulk-add:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy2.csv clear
	@${PREFIX} ${EXE} dummy2.csv add 1-1 OLD_V1 --no-timestamp # for old value test
	@${PREFIX} ${EXE} dummy2.csv add 2-1 OLD_VAL2 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv bulk-add overwrite.csv
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n1,1,VAL1,1731620001,\n2,1,OLD_VAL2,,\n3,1,VAL3,,\n4,1,VAL4,1731620001,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}

test-bulk-remove:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy2.csv clear
	@${PREFIX} ${EXE} dummy2.csv add 1-1 OLD_V1 --no-timestamp # for old value test
	@${PREFIX} ${EXE} dummy2.csv add 2-1 OLD_VAL2 --no-timestamp
	@${PREFIX} ${EXE} dummy2.csv bulk-add overwrite.csv
	@${PREFIX} ${EXE} dummy2.csv bulk-remove remove.csv
	@${CHECK} [ "`${EXE} dummy2.csv list`" = "`printf \"$(HEADER)\n3,1,VAL3,,\n\"`" ] \
		&& ${TEST_PASS} || ${TEST_FAIL}

STAT_MOD_TS=$(shell if stat -c %Y Makefile >/dev/null 2>/dev/null; then echo 'stat -c %Y' ; else echo 'stat -f %m' ; fi)
test-timestamp:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy2.csv clear
	@(${PREFIX} ${EXE} dummy2.csv add 1-2 ABC && ${STAT_MOD_TS} .zsv/data/dummy2.csv/overwrite.sqlite3 > ${TMP_DIR}/timestamp1.txt)
	@(${PREFIX} ${EXE} dummy2.csv add 1-3 ABC && ${STAT_MOD_TS} .zsv/data/dummy2.csv/overwrite.sqlite3 > ${TMP_DIR}/timestamp2.txt)
	@{ \
		EXPECTED_TS1=`cat ${TMP_DIR}/timestamp1.txt`; \
		EXPECTED_TS2=`cat ${TMP_DIR}/timestamp2.txt`; \
		LOWER_TS1=$$((EXPECTED_TS1 - 3)); \
		LOWER_TS2=$$((EXPECTED_TS2 - 3)); \
		OUTPUT="`${EXE} dummy2.csv list | tr -d '\n'`"; \
		echo "$$OUTPUT" | grep -q "${HEADER}1,2,ABC,\($$LOWER_TS1\|$$EXPECTED_TS1\),1,3,ABC,\($$LOWER_TS2\|$$EXPECTED_TS2\)," && ${TEST_PASS} || ${TEST_FAIL}; \
	}

test-echo-overwrite-auto:
	@${TEST_INIT}
	@${PREFIX} ${EXE} dummy.csv clear
	@${PREFIX} ${EXE} dummy.csv add 1-0 ABC
	@${PREFIX} ${EXE} dummy.csv add 2-2 123
	@${ECHO_EXE} --apply-overwrites dummy.csv > ${TMP_DIR}/$@.out
	@${CMP} ${TMP_DIR}/$@.out expected/$@.out && ${TEST_PASS} || ${TEST_FAIL}

clean:
	@rm -rf ${TMP_DIR}

.PHONY: help test% clean

=== debian/changelog ===
zsv (1.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1119153)

 -- Azeem Sajid <azeem.sajid@gmail.com>  Tue, 17 Feb 2026 15:50:36 +0500

=== debian/control ===
Source: zsv
Section: utils
Priority: optional
Maintainer: Azeem Sajid <azeem.sajid@gmail.com>
Build-Depends: debhelper-compat (= 13), libncurses-dev
Standards-Version: 4.7.2
Homepage: https://github.com/liquidaty/zsv
Vcs-Browser: https://github.com/liquidaty/zsv
Vcs-Git: https://github.com/liquidaty/zsv.git
Rules-Requires-Root: no

Package: zsv
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tabular data swiss-army knife CLI
 zsv is a fast and extensible CLI utility for CSV data.
 It achieves high performance using SIMD operations,
 efficient memory use and other optimization techniques,
 and can also parse generic-delimited and fixed-width
 formats, as well as multi-row-span headers.

Package: zsv-dev
Architecture: any
Depends: ${misc:Depends}
Description: world's fastest (SIMD) CSV parser library
 zsv-dev contains the development files for the zsv
 library, which can be used to parse CSV and other
 tabular data formats in your own C programs.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	./configure --prefix=$(CURDIR)/debian/tmp

override_dh_auto_build:

override_dh_builddeb:
	dh_builddeb -- -Zxz

override_dh_auto_install:
	$(MAKE) install

override_dh_auto_test:

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_clean:
	[ -f config.mk ] && $(MAKE) clean || echo 'No config.mk found, skipping clean'

=== debian/watch ===
version=4
https://github.com/liquidaty/zsv/tags .*/v?(\d.*)@ARCHIVE_EXT@
